SystemOrganization addCategory: #'Glamour-Morphic-Renderer'!
SystemOrganization addCategory: 'Glamour-Morphic-Renderer-Spotter'!

!GLMAction methodsFor: '*glamour-morphic-renderer' stamp: 'AndreiChis 1/21/2016 10:26'!
installKeyCombinationForPresentation: aPresentation onMorph: aMorph
	aMorph 
		bindKeyCombination: self keymap		
		toAction: [ self actOn: aPresentation ].
	! !

!GLMAction methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 8/9/2011 13:56'!
morphicActOn: aPresentation

	^ self actOn: aPresentation! !

GLMAction subclass: #GLMMorphicAction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAction commentStamp: '<historical>' prior: 0!
A GLMMorphicAction is special GLMAction that is only active when rendering Glamour browsers with Morphic.!

!GLMMorphicAction methodsFor: 'testing' stamp: 'tg 9/24/2010 15:36'!
worksWithMorphic
	^ true! !

GLMRenderer subclass: #GLMMorphicRenderer
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicRenderer commentStamp: 'tg 4/1/2010 07:11' prior: 0!
This is the class responsible for the binding to Morphic.

| browser |
browser := GLMTabulator new.
browser column: #one; column: #two.

browser transmit to: #one; andShow: [:a | a list.].
browser transmit to: #two; from: #one; andShow: [ :a |
	a text.].
browser openOn: #(a b c d)!

!GLMMorphicRenderer methodsFor: 'opening' stamp: 'TudorGirba 10/19/2013 03:48'!
open: aRenderable
	window := GLMMorphicWindowRenderer render: aRenderable from: self.
	^ window openInWorld ! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:31'!
renderAccordionCompositePresentation: aCompositePresentation
	^ GLMMorphicAccordionRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:51'!
renderAccumulator: aBrowser 
	^ GLMMorphicAccumulatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering actions' stamp: 'AndreiChis 3/27/2015 17:45'!
renderAction: anAction
	^ GLMMorphicActionRenderer render: anAction from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'EstebanLorenzano 4/20/2012 16:14'!
renderActionListPresentation: anActionListPresentation 
	^GLMMorphicActionListRenderer render: anActionListPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'cyrilledelaunay 6/7/2011 17:01'!
renderDashboard: aBrowser 
	^ GLMMorphicDashboardRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 9/3/2010 13:56'!
renderDiffPresentation: aPresentation
	^ GLMMorphicDiffRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 6/29/2012 09:47'!
renderDropDownListPresentation: aDropListPresentation
	^ GLMMorphicDropDownRenderer render: aDropListPresentation from: self	! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 2/4/2011 18:10'!
renderDynamicPresentation: aPresentation
	^ GLMMorphicDynamicRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'TudorGirba 1/2/2011 18:58'!
renderExpander: aBrowser 
	^ GLMMorphicExpanderRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'TudorGirba 2/15/2011 18:07'!
renderFinder: aBrowser 
	^ aBrowser hasFixedSizePanes 
		ifTrue: [GLMMorphicFixedPanesFinderRenderer render: aBrowser from: self]
		ifFalse: [GLMMorphicVariablePanesFinderRenderer render: aBrowser from: self]! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 7/1/2011 23:15'!
renderLabelPresentation: aLabelPresentation 
	^ GLMMorphicLabelRenderer render: aLabelPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:14'!
renderListPresentation: aListPresentation 
	^ GLMMorphicListRenderer render: aListPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:12'!
renderListingPresentation: aPresentation 
	^ GLMMorphicListingRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'EstebanLorenzano 10/6/2011 22:29'!
renderMorphPresentation: aMorphPresentation 
	^ GLMMorphicMorphRenderer render: aMorphPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 21:51'!
renderPane: aPane 
	^ GLMMorphicPaneRenderer render: aPane from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 5/17/2014 09:19'!
renderPharoMethodPresentation: aSmalltalkMethodPresentation 
	^ GLMMorphicPharoMethodRenderer render: aSmalltalkMethodPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 10/30/2015 14:20'!
renderPharoScriptPresentation: aPharoScriptPresentation 
	^ GLMMorphicPharoScriptRenderer render: aPharoScriptPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering actions' stamp: 'AndreiChis 3/27/2015 17:50'!
renderPopupAction: anAction
	^ GLMMorphicPopupActionRenderer render: anAction from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'AndreiChis 4/22/2014 20:50'!
renderRubricHighlightedTextPresentation: aPresentation

	^ GLMMorphicRubricHighlightedTextRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 6/2/2013 21:48'!
renderRubricTextPresentation: aPresentation
	^ GLMMorphicRubricTextRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 8/29/2011 23:51'!
renderSmalltalkCodePresentation: aSmalltalkCodePresentation 
	^ GLMMorphicSmalltalkCodeRenderer render: aSmalltalkCodePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'TudorGirba 4/3/2013 16:57'!
renderSpecPresentation: aPresentation 
	^ GLMMorphicSpecRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:31'!
renderStackedVerticallyCompositePresentation: aCompositePresentation
	^ GLMMorphicVerticallyStackedRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:50'!
renderStacker: aBrowser 
	^ GLMMorphicStackerRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:33'!
renderTabbedCompositePresentation: aCompositePresentation
	^ GLMMorphicTabbedRenderer render: aCompositePresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:15'!
renderTablePresentation: aPresentation 
	^ GLMMorphicTableRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'tg 8/24/2010 21:50'!
renderTabulator: aBrowser 
	^ GLMMorphicTabulatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 20:22'!
renderTextPresentation: aTextPresentation 
	^ GLMMorphicTextRenderer render: aTextPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering presentations' stamp: 'tg 8/22/2010 23:16'!
renderTreePresentation: aPresentation 
	^ GLMMorphicTreeRenderer render: aPresentation from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'cyrilledelaunay 5/5/2011 12:03'!
renderValidator: aBrowser 

	| tmpValidatorRenderer |
	tmpValidatorRenderer :=  GLMMorphicValidatorRenderer new.
	aBrowser  setSpecificAnnouncementActionsTo: tmpValidatorRenderer.  
	^ tmpValidatorRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'TudorGirba 4/12/2011 13:49'!
renderWizard: aGLMWizard

	|tmpRenderer|
	tmpRenderer :=  GLMMorphicWizardRenderer new.
	aGLMWizard  setSpecificAnnouncementActionsTo: tmpRenderer.  
	^ (tmpRenderer renderer: self) render: aGLMWizard! !

!GLMMorphicRenderer methodsFor: 'rendering browsers' stamp: 'TudorGirba 5/18/2012 22:29'!
renderWrapper: aBrowser 
	^ GLMMorphicWrapperRenderer render: aBrowser from: self! !

!GLMMorphicRenderer methodsFor: 'accessing' stamp: 'tg 8/23/2010 00:33'!
window
	^ window! !

!GLMMorphicRenderer methodsFor: 'accessing' stamp: 'tg 8/23/2010 00:33'!
window: anObject
	window := anObject! !

Object subclass: #GLMMorphicWidgetRenderer
	instanceVariableNames: 'renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWidgetRenderer commentStamp: '<historical>' prior: 0!
This is a helper class that is supposed to be subclassed for each rendering logic of a specific morph. For example, there will be a TreeRenderer, a TextRenderer etc!

GLMMorphicWidgetRenderer subclass: #GLMMorphicActionListRenderer
	instanceVariableNames: 'labelMorph container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicActionListRenderer class methodsFor: 'defaults' stamp: 'EstebanLorenzano 12/12/2011 20:05'!
defaultWidth 
	^100! !

!GLMMorphicActionListRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 12/12/2011 22:00'!
actOnPresentationUpdated: ann
	container removeAllMorphs.
	container addMorphBack: (self morphFrom: ann presentation)! !

!GLMMorphicActionListRenderer methodsFor: 'private' stamp: 'EstebanLorenzano 12/12/2011 19:40'!
buttonMorph: aModel
	^UITheme current 
		newButtonIn: nil 
		for: aModel 
		getState: nil
		action: #execute
		arguments: nil 
		getEnabled: nil 
		label: aModel buttonLabel
		help: nil! !

!GLMMorphicActionListRenderer methodsFor: 'rendering' stamp: 'AndreiChis 8/6/2013 18:30'!
morphFrom: anActionListPresentation 
	| buttonsContainer buttonModel button |
	
	buttonsContainer := self rectangleMorphFrom: anActionListPresentation.
	
	anActionListPresentation allActions do: [ :each | 
		buttonModel := GLMButtonModel new.
		buttonModel glamourPresentation: anActionListPresentation.
		buttonModel glamourAction: each.

		button := self buttonMorph: buttonModel.
		buttonsContainer addMorphBack: button.
		button width: self class defaultWidth ].
	
	^ buttonsContainer! !

!GLMMorphicActionListRenderer methodsFor: 'private' stamp: 'TudorGirba 11/1/2013 23:33'!
rectangleMorphFrom: anActionListPresentation
	^ BorderedMorph new
		borderWidth: 0;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellPositioning: #topLeft;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		listDirection: (anActionListPresentation isHorizontal 
			ifTrue: [ #leftToRight ] 
			ifFalse: [ #topToBottom ] );
		listCentering: #topLeft;
		wrapCentering: #topLeft;
		cellInset: 5;
		yourself! !

!GLMMorphicActionListRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:38'!
render: anActionListPresentation
	container := GLMMorphic containerMorph.
	container
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	container addMorphBack: (self morphFrom: anActionListPresentation).
	anActionListPresentation when: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicActionRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicActionRenderer methodsFor: 'accessing' stamp: 'AndreiChis 3/27/2015 17:54'!
actionArguments
	^ {  }! !

!GLMMorphicActionRenderer methodsFor: 'accessing' stamp: 'AndreiChis 3/27/2015 17:47'!
actionSelector
	^ #morphicActOn:! !

!GLMMorphicActionRenderer methodsFor: 'rendering' stamp: 'HilaireFernandes 2/7/2017 19:20'!
render: anAction
	|b|
	b := GLMPluggableButtonMorph
			on: anAction getState: nil action: self actionSelector.
	b
		theme: UITheme current;
		arguments: (self actionArguments ifNil: [{b}]);
		cornerStyle: (UITheme current buttonCornerStyleIn: nil);
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		getEnabledSelector: nil;
		setBalloonText: ((anAction help ifNil: [ anAction title]) , Character tab asString , anAction shortcutAsString) trimBoth;
		extent: b minExtent;
		removeProperty: #theme.
	anAction shouldShowTitle 
		ifTrue: [ b 
				icon: anAction icon ;
				label: anAction title font: UITheme current buttonFont ]
		ifFalse: [ b label: (AlphaImageMorph new image: anAction icon) ].
	
	"this is a hack to tell the GLMUITheme to not draw the border and the fill, and to disable the focus"
	b 
		valueOfProperty: #noBorder ifAbsentPut: [ true ];
		valueOfProperty: #noFill ifAbsentPut: [ true ];
		setProperty: #wantsKeyboardFocusNavigation toValue: false;
		borderWidth: 0.
	^ b	! !

GLMMorphicActionRenderer subclass: #GLMMorphicPopupActionRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPopupActionRenderer methodsFor: 'accessing' stamp: 'AndreiChis 3/27/2015 17:54'!
actionArguments
	^ nil! !

!GLMMorphicPopupActionRenderer methodsFor: 'accessing' stamp: 'AndreiChis 3/27/2015 17:48'!
actionSelector
	^ #popupActOn:from:! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicBrowserRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicBrowserRenderer subclass: #GLMMorphicAccumulatorRenderer
	instanceVariableNames: 'tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAccumulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 12:25'!
actOnPaneAdded: ann 
	tabs 
		addLazyPage: (GLMMorphicPaneWithoutTitleRenderer new render: ann pane) 
		label: (self titleOrIconOf: ann pane presentations in: tabs)
		toolbar: nil
		collapsable: true.
	tabs selectedPageIndex: tabs pages size! !

!GLMMorphicAccumulatorRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 10:50'!
actOnPaneSelected: anAnnouncement
	tabs selectedPageIndex: anAnnouncement position! !

!GLMMorphicAccumulatorRenderer methodsFor: 'private' stamp: 'TudorGirba 7/23/2011 20:26'!
removePage: aPage
	| removedPageIndex |
	removedPageIndex := self pages indexOf: aPage.
	self announcer suspendAllWhile: [ super removePage: aPage ].
	self announcer announce: 
		(LazyTabPageRemoved new 
			tabs: self; 
			page: aPage; 
			pageIndex: removedPageIndex;
			newIndex: self tabSelectorMorph selectedIndex).
	self pages isEmpty 
		ifTrue: [ self contentMorph removeAllMorphs ]! !

!GLMMorphicAccumulatorRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:39'!
render: aBrowser
	aBrowser panes isEmpty
		ifTrue: [ ^ GLMMorphic emptyMorph ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	tabs announcer
		when: LazyTabPageChanged
		do: [ :ann | aBrowser activeEntity: ((aBrowser panes at: ann pageIndex) port: #entity) value ].
	tabs announcer
		when: LazyTabPageRemoved
		do: [ :ann | 
			aBrowser removePaneIndex: ann pageIndex.
			aBrowser panes isEmpty
				ifTrue: [ aBrowser activeEntity: nil ]
				ifFalse: [ aBrowser activeEntity: ((aBrowser panes at: ann newIndex) port: #entity) value ] ].
	aBrowser panes
		do: [ :each | 
			tabs
				addLazyPage: [ GLMMorphicPaneWithoutTitleRenderer new render: each ]
				label: (self titleOrIconOf: each presentations in: tabs)
				toolbar: (self renderToolbarForPresentation: each presentations inMorph: tabs)
				collapsable: true ].
	aBrowser when: GLMPaneSelected send: #actOnPaneSelected: to: self.
	aBrowser when: GLMPaneAdded send: #actOnPaneAdded: to: self.
	aBrowser when: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	tabs selectedPageIndex: tabs pages size.
	^ tabs! !

!GLMMorphicBrowserRenderer methodsFor: 'callbacks' stamp: 'TudorGirba 4/12/2011 12:49'!
actOnBrowserClosed: ann
	self renderer window delete! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicDashboardRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicDashboardRenderer methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2017 15:11'!
render: aBrowser
	| container |
	container := GLMPanelMorph new.
	container
		fillStyle: Color transparent;
		changeProportionalLayout;
		hResizing: #spaceFill;
		vResizing: #spaceFill.
	aBrowser panes reverseDo: [ :aGLMPane | self renderPane: aGLMPane inUI: container from: aBrowser ].
	aBrowser when: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ container! !

!GLMMorphicDashboardRenderer methodsFor: 'private' stamp: 'CyrilFerlicot 12/14/2015 18:04'!
renderPane: aPane inUI: aMorph from: aDashboard
	aMorph addMorph: (self renderObject: aPane) fullFrame: (aDashboard layoutOfPaneNamed: aPane name)! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicDropDownRenderer
	instanceVariableNames: 'listModel dropDownMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicDropDownRenderer methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/20/2013 23:11'!
actOnContextChanged: ann 
	ann property = #selection ifTrue: [ 
		listModel announcer suspendAllWhile: [
			dropDownMorph listSelectionIndex: (listModel glamourPresentation displayValue indexOf: ann value) ] ]! !

!GLMMorphicDropDownRenderer methodsFor: 'as yet unclassified' stamp: 'AndreiChis 8/21/2013 16:02'!
actOnPresentationUpdated: ann

	listModel resetData.
	dropDownMorph 
		updateList;
		updateListSelectionIndex
	 ! !

!GLMMorphicDropDownRenderer methodsFor: 'as yet unclassified' stamp: 'CyrilFerlicot 5/22/2015 14:40'!
render: aDropListPresentation
	listModel := GLMDropListModel new glamourPresentation: aDropListPresentation.	"When the morph changes, we want to update the glamour model"
	listModel announcer
		when: GLMDropDownListMorphSelectionChanged
		do: [ :ann | 
			aDropListPresentation selectedIndex: ann selectionIndex.
			aDropListPresentation selection: ann selectionValue ].
	listModel selectionIndex: aDropListPresentation selectedIndex.
	dropDownMorph := (MorphDropListMorph
		on: listModel
		list: #list
		selected: #selectionIndex
		changeSelected: #selectionIndex:
		useIndex: true)
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	aDropListPresentation when: GLMContextChanged send: #actOnContextChanged: to: self.
	aDropListPresentation when: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ dropDownMorph! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicExpanderRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicExpanderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/26/2012 10:47'!
render: aBrowser
	^ self renderWithExpanders: aBrowser   ! !

!GLMMorphicExpanderRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 2/9/2017 15:11'!
renderWithExpanders: aBrowser
	| morph scroll panel expander |
	panel := GLMPanelMorph new.
	panel 
		fillStyle: Color transparent;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap;
		changeTableLayout;
		layoutInset: 2;
		cellInset: 2.
	scroll := GeneralScrollPane new.
	scroll 
		changeScrollerTableLayout;
		scrollTarget: panel.
	aBrowser panes do: [:each |
		expander := ExpanderMorph titleText: (each presentations titleValue ifNil: ['noname']).
		morph := GLMMorphicPaneWithoutTitleRenderer new render: each.
		morph 
			borderStyle: (UITheme current buttonSelectedBorderStyleFor: morph).
		expander addMorphBack: morph.
		panel addMorph: expander	].
	^ scroll! !

!GLMMorphicExpanderRenderer methodsFor: 'rendering' stamp: 'StephaneDucasse 1/9/2016 10:09'!
renderWithTree: aBrowser
	| treeMorph treeModel |
	treeModel := GLMExpanderTreeMorphModel new glamourExpander: aBrowser.
	treeMorph := MorphTreeMorph new.
	treeMorph
		makeLastColumnUnbounded;
		getMenuSelector: #menu:shifted:;
		keystrokeActionSelector: #keyStroke:from:;
		cornerStyle: treeMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 1);
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutFrame: (LayoutFrame identity);
		preferedPaneColor: Color white;	
		model: treeModel;
		columns: ( OrderedCollection with: (MorphTreeColumn new rowMorphGetSelector: #elementColumn)).
	treeMorph vShowScrollBar.
	aBrowser when: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ treeMorph buildContents! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicFinderRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneAdded: ann
	self subclassResponsibility! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
actOnPaneRemoved: ann
	self subclassResponsibility! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
actOnPaneReplaced: ann
	self subclassResponsibility! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:17'!
registerAnnouncementsFor: aBrowser
	aBrowser when: GLMPaneRemoved send: #actOnPaneRemoved: to: self.
	aBrowser when: GLMPaneAdded send: #actOnPaneAdded: to: self.
	aBrowser when: GLMPaneReplaced send: #actOnPaneReplaced: to: self.
	aBrowser when: GLMBrowserClosed send: #actOnBrowserClosed: to: self! !

!GLMMorphicFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:09'!
render: aBrowser
	^ self subclassResponsibility! !

GLMMorphicFinderRenderer subclass: #GLMMorphicFixedPanesFinderRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneAdded: ann
	container pushPane: (self renderObject: ann pane)! !

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneRemoved: ann
	container popPane! !

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:10'!
actOnPaneReplaced: ann
	container popAndReplacePane: (self renderObject: ann newPane)! !

!GLMMorphicFixedPanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
render: aBrowser
	container := GLMPaneScroller new
		name: 'scroller';
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		yourself.
	container maxPanes: aBrowser fixedSizePanes.
	self registerAnnouncementsFor: aBrowser.  
	aBrowser panes
		do: [ :each | container pushPane: (self renderObject: each) ].
	^ container! !

GLMMorphicFinderRenderer subclass: #GLMMorphicVariablePanesFinderRenderer
	instanceVariableNames: 'scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:12'!
actOnPaneAdded: ann
	self addMorphFromObject: ann pane toContainer: container.
	scrollPane hScrollbar glmAnimateValue: 1.0 duration: 2000! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:12'!
actOnPaneRemoved: ann
	container removeMorph: container submorphs last.
	container removeMorph: container submorphs last! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:13'!
actOnPaneReplaced: ann
	container removeMorph: container submorphs last.
	container removeMorph: container submorphs last.
	self addMorphFromObject: ann newPane toContainer: container.
	scrollPane hScrollbar glmAnimateValue: 1.0 duration: 200! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:11'!
addMorphFromObject: anObject toContainer: aContainerMorph
	| renderedMorph |
	renderedMorph := (self renderObject: anObject)
				vResizing: #spaceFill;
				hResizing: #rigid;
				minimumExtent: 200@10;
				extent: 200@10;
				yourself.
	aContainerMorph addMorphBack: renderedMorph.
	aContainerMorph addMorphBack: (EdgeGripMorph new
		width: ProportionalSplitterMorph splitterWidth;
		hResizing: #rigid; "not the default this time, vResizing is also #spaceFill by default"
		target: renderedMorph)! !

!GLMMorphicVariablePanesFinderRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 18:13'!
render: aBrowser
	container := GLMMorphic containerMorph.
	container 
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #spaceFill;
		hResizing: #shrinkWrap.
	scrollPane := GeneralScrollPane new
		changeScrollerTableLayout;
		scrollTarget: container;
		yourself.
	self registerAnnouncementsFor: aBrowser.  
	aBrowser panes do: [ :each | self addMorphFromObject: each toContainer: container ].
	^ scrollPane! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicStackerRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicStackerRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 7/25/2016 15:08'!
render: aBrowser
	| tabs |
	aBrowser panes isEmpty
		ifTrue: [ ^ GLMMorphic emptyMorph ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	aBrowser panes
		do: [ :each | 
			self flag: 'add toolbar'.
			tabs
				addLazyPage: [ 
					GLMMorphicPaneWithoutTitleRenderer new 
						renderer: self renderer;
						render: each ]
				label: (self titleOrIconOf: each presentations in: tabs)
				toolbar: (self renderToolbarForPresentation: each presentations inMorph: tabs) ].
	tabs selectedPageIndex: 1.
	aBrowser when: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ tabs! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicTabulatorRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTabulatorRenderer methodsFor: 'private' stamp: 'TudorGirba 1/9/2016 00:31'!
margin
	^ 1! !

!GLMMorphicTabulatorRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:30'!
render: aBrowser
	| container |
	container := GLMMorphic containerMorph.
	aBrowser cell isRow
		ifTrue: [ 
			self
				renderCustomRow: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ]
		ifFalse: [ 
			self
				renderCustomColumn: aBrowser cell
				ofPane: aBrowser pane
				inUI: container
				inBrowser: aBrowser ].
	aBrowser when: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ container! !

!GLMMorphicTabulatorRenderer methodsFor: 'private' stamp: 'AndreiChis 7/23/2014 17:52'!
renderCustomColumn: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children
		keysAndValuesDo: [ :index :each | 
			each hasId
				ifTrue: [ pane := self renderObject: (aBrowser paneNamed: each id) ]
				ifFalse: [ 
					pane := GLMMorphic containerMorph.
					self
						renderCustomRow: each
						ofPane: aPane
						inUI: pane
						inBrowser: aBrowser.
					pane addPaneSplitters ].
			pane
				layoutFrame:
					(LayoutFrame new
						topFraction: currentSpanPosition / totalSpans offset: currentOffset + self margin;
						leftFraction: 0 offset: 0;
						bottomFraction: (currentSpanPosition + each span) / totalSpans offset: currentOffset + each size - self margin;
						rightFraction: 1 offset: 0;
						yourself).
			aMorph addMorphBack: pane.
			currentSpanPosition := currentSpanPosition + each span.
			currentOffset := currentOffset + each size ].
	aCell children last size > 0
		ifTrue: [ 
			(aMorph submorphs atLast: 2) layoutFrame
				bottomOffset: (aMorph submorphs atLast: 2) layoutFrame bottomOffset - currentOffset.
			aMorph submorphs last layoutFrame topOffset: aMorph submorphs last layoutFrame topOffset - currentOffset.
			aMorph submorphs last layoutFrame
				bottomOffset: aMorph submorphs last layoutFrame bottomOffset - currentOffset ].
	aMorph addPaneSplitters! !

!GLMMorphicTabulatorRenderer methodsFor: 'private' stamp: 'AndreiChis 7/23/2014 17:45'!
renderCustomRow: aCell ofPane: aPane inUI: aMorph inBrowser: aBrowser 
	| pane totalSpans currentSpanPosition currentOffset |
	totalSpans := aCell children inject: 0 into: [ :sum :each | sum + each span ].
	currentSpanPosition := 0.
	currentOffset := 0.
	aCell children keysAndValuesDo: [ :index :each | 
		each hasId 
			ifTrue: [ pane := self renderObject: (aBrowser paneNamed: each id) ]
			ifFalse: [ 
				pane := GLMMorphic containerMorph.
				self 
					renderCustomColumn: each
					ofPane: aPane
					inUI: pane
					inBrowser: aBrowser.
				pane addPaneSplitters ].
		pane layoutFrame: (LayoutFrame new
				topFraction: 0 offset: 0;
				leftFraction: currentSpanPosition / totalSpans offset: currentOffset + self margin;
				bottomFraction: 1 offset: 0;
				rightFraction: (currentSpanPosition + each span) / totalSpans offset: currentOffset + each size - self margin;
				yourself).
		aMorph addMorphBack: pane.
		currentSpanPosition := currentSpanPosition + each span.
		currentOffset := currentOffset + each size ].
	(aCell children last size > 0) ifTrue: [
		(aMorph submorphs atLast: 2) layoutFrame rightOffset: (aMorph submorphs atLast: 2) layoutFrame rightOffset - currentOffset. 
		aMorph submorphs last layoutFrame leftOffset: aMorph submorphs last layoutFrame leftOffset - currentOffset. 
		aMorph submorphs last layoutFrame rightOffset: aMorph submorphs last layoutFrame rightOffset - currentOffset.].
	aMorph addPaneSplitters! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicValidatorRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicValidatorRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:48'!
render: aBrowser
	| tmpButtons |
	tmpButtons := OrderedCollection new.
	aBrowser panes isEmpty
		ifTrue: [ 
			"|tmpPane|
		tmpPane := (GLMPane in: aBrowser) 
				addPresentation: aBrowser presentations; 
				yourself.	
		(tmpPane port: #entity) value: aBrowser entity.	
		aBrowser panes add: tmpPane"
			 ].
	aBrowser buttonActions
		do: [ :aGLMAction | 
			| buttonModel |
			buttonModel := GLMButtonModel new.
			buttonModel glamourPresentation: aBrowser.
			buttonModel glamourAction: aGLMAction.
			tmpButtons
				add:
					(PluggableButtonMorph
						on: buttonModel
						getState: nil
						action: #execute
						label: #buttonLabel) ].
	aBrowser when: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	container := GLMMorphicValidatorPaneRenderer new
		buttons: tmpButtons;
		render: aBrowser panes anyOne.
	^ container! !

!GLMMorphicValidatorRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 13:25'!
render: aBrowser from: aGLMRenderer

	self renderer: aGLMRenderer.
	^ self render: aBrowser
	! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicWizardRenderer
	instanceVariableNames: 'scrollPane container parentRenderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/4/2011 14:52'!
actOnPaneAdded: ann
	container removeMorph: container submorphs last.
	self addMorphFromObject: ann pane toContainer: container.! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/4/2011 15:53'!
actOnPaneRemoved: ann! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/31/2011 16:33'!
actOnPaneReplaced: ann

	container removeMorph: container submorphs last.
	self addMorphFromObject: ann newPane toContainer: container.
	"scrollPane hScrollbar glmAnimateValue: 1.0 duration: 200"! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/31/2011 17:25'!
addMorphFromObject: anObject toContainer: aContainerMorph

	| renderedMorph |
	renderedMorph := (self renderObject: anObject).
				"vResizing: #spaceFill;
				hResizing: #rigid;
				minimumExtent: 200@10;
				extent: 200@10;
				yourself."
	aContainerMorph addMorphBack: renderedMorph.! !

!GLMMorphicWizardRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 4/1/2011 14:16'!
parentRenderer

	^ parentRenderer! !

!GLMMorphicWizardRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 4/1/2011 14:17'!
parentRenderer: aGLMMorphicRenderer

	parentRenderer := aGLMMorphicRenderer! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:42'!
registerAnnouncementsFor: aBrowser
	aBrowser when: GLMPaneRemoved send: #actOnPaneRemoved: to: self.
	aBrowser when: GLMPaneAdded send: #actOnPaneAdded: to: self.
	aBrowser when: GLMPaneReplaced send: #actOnPaneReplaced: to: self.
	aBrowser when: GLMBrowserClosed send: #actOnBrowserClosed: to: self! !

!GLMMorphicWizardRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 4/4/2011 16:43'!
render: aBrowser
	container := GLMMorphic containerMorph.
	container
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	scrollPane := GeneralScrollPane new
		changeScrollerTableLayout;
		scrollTarget: container;
		yourself.
	self registerAnnouncementsFor: aBrowser.  
	self addMorphFromObject: (aBrowser stepsAndPanes at: aBrowser currentStep) last toContainer: container .
	^ scrollPane! !

GLMMorphicBrowserRenderer subclass: #GLMMorphicWrapperRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWrapperRenderer methodsFor: 'rendering' stamp: 'StephaneDucasse 1/9/2016 10:08'!
render: aBrowser
	| paneMorph |
	container := GLMMorphic containerMorph.
	paneMorph := self renderObject: aBrowser defaultPane.
	paneMorph layoutFrame: (LayoutFrame identity).
	container addMorphBack: paneMorph.
	aBrowser when: GLMBrowserClosed send: #actOnBrowserClosed: to: self.
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicCompositeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicCompositeRenderer subclass: #GLMMorphicAccordionRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicAccordionRenderer methodsFor: 'rendering' stamp: 'VincentBlondeau 2/16/2014 12:38'!
render: aPresentation
	| presentations container expander |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty
		ifTrue: [ ^ GLMMorphic emptyMorph ].
	presentations size = 1
		ifTrue: [ ^ self renderWithToolbar: presentations first ].
	container := GLMMorphic containerMorph.
	container changeTableLayout.
	presentations
		do: [ :each | 
			expander := self theme
				newExpanderIn: container
				label: (self titleOrIconOf: each in: container)
				forAll: {(self renderWithToolbar: each)}.
			container addMorphBack: expander.
			(aPresentation pane lastActivePresentation notNil
				and: [ each title = aPresentation pane lastActivePresentation title ])
				ifTrue: [ expander expanded: true ] ].
	(aPresentation pane lastActivePresentation isNil and: [ container submorphs notEmpty ])
		ifTrue: [ container submorphs first expanded: true ].
	^ container! !

GLMMorphicCompositeRenderer subclass: #GLMMorphicTabbedRenderer
	instanceVariableNames: 'tabs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTabbedRenderer methodsFor: 'rendering' stamp: 'AndreiChis 6/23/2014 15:37'!
actOnContextChanged: ann
	ann property = #activePresentation ifTrue: [ 
		tabs announcer suspendAllWhile: [ tabs selectedPageIndex: (ann presentation matchingPresentations indexOf: ann value) ] ]! !

!GLMMorphicTabbedRenderer methodsFor: 'rendering' stamp: 'AndreiChis 10/7/2014 14:06'!
actOnPresentationToolbarUpdated: ann
	| presentations |

	presentations := ann presentation matchingPresentations.
	tabs pages size to: 1 by: -1 do: [ :i | (tabs pages at: i) toolbar: GLMMorphic emptyMorph ].	
	presentations withIndexDo: [ :each :i | 
		tabs updatePageAtIndex: i
			withLabel: (self titleOrIconOf: each in: tabs)
			toolbar: (self renderToolbarForPresentation: each inMorph: tabs)
			action: (self labelActionMorphFor: each)]! !

!GLMMorphicTabbedRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 3/22/2015 11:48'!
actOnPresentationUpdated: ann
	| index presentations |
	presentations := ann presentation matchingPresentations.
	tabs pages size to: 1 by: -1 do: [ :i | tabs removePageIndex: i ].	
	presentations do: [ :each | 
		tabs 
			addLazyPage: [ self renderObject: each ]
			label: (self titleOrIconOf: each in: tabs)
			toolbar: (self renderToolbarForPresentation: each inMorph: tabs )
			action: (self labelActionBrickFor: each) ].
	index := 1.
	presentations withIndexDo: [ :each :i | 
		ann presentation pane lastActivePresentation notNil and: [ 
			each title = ann presentation pane lastActivePresentation title ifTrue: [ 
				index := i ] ] ].
	tabs selectedPageIndex: index.! !

!GLMMorphicTabbedRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:32'!
render: aPresentation
	| presentations index |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty
		ifTrue: [ ^ GLMMorphic emptyMorph ].
	(presentations size = 1 and: [ presentations first hasTitle not ])
		ifTrue: [ ^ self renderWithTitleOrNil: presentations first ].
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme buttonFont.
	tabs announcer
		when: LazyTabPageChanged
		do: [ :ann | 
			aPresentation announcer
				suspendAllWhile: [ aPresentation pane lastActivePresentation: (aPresentation matchingPresentations at: ann pageIndex) ] ].
	presentations
		do: [ :each | 
			tabs
				addLazyPage: [ self renderObject: each ]
				label: (self titleOrIconOf: each in: tabs)
				toolbar: (self renderToolbarForPresentation: each inMorph: tabs)
				action: (self labelActionBrickFor: each) ].
	index := 1.
	presentations
		withIndexDo: [ :each :i | 
			(aPresentation pane isLastActivePresentation: each)
				ifTrue: [ index := i ] ].
	tabs announcer suspendAllWhile: [ tabs selectedPageIndex: index ].
	aPresentation when: GLMContextChanged send: #actOnContextChanged: to: self.
	aPresentation when: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	aPresentation when: GLMPresentationToolbarUpdated send: #actOnPresentationToolbarUpdated: to: self.
	^ tabs! !

GLMMorphicCompositeRenderer subclass: #GLMMorphicVerticallyStackedRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicVerticallyStackedRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/20/2011 21:55'!
render: aPresentation
	| presentations container |
	presentations := aPresentation matchingPresentations.
	presentations isEmpty ifTrue: [ ^ GLMMorphic emptyMorph ].	
	container := GLMMorphic containerMorph.
	container changeTableLayout.
	presentations do: [ :each | 
		container addMorphBack: (self renderWithTitle: each) ].
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicDiffRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicDiffRenderer methodsFor: 'rendering' stamp: 'StephaneDucasse 1/9/2016 10:09'!
render: aPresentation
	| textMorph |
	textMorph := (DiffMorph
		from: aPresentation displayValue first
		to: aPresentation displayValue last
		contextClass: aPresentation contextClassValue)
"			onKeyStrokeSend: #keystroke:from: to: textModel;
"			layoutFrame: (LayoutFrame identity);
			vResizing: #spaceFill;
			hResizing: #spaceFill;
			yourself.
"	self installActionsOnUI: textModel fromPresentation: aTextPresentation.
	aTextPresentation selectedTextBlock: [ textMorph textMorph editor selection ].
	aTextPresentation textBlock: [ textMorph textMorph editor text ].
"	^textMorph! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicDynamicRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicDynamicRenderer methodsFor: 'rendering' stamp: 'StephaneDucasse 1/9/2016 10:09'!
actOnPresentationUpdated: anAnnouncement
	container removeAllMorphs.
	container 
		addMorph: (self renderObject: anAnnouncement presentation currentPresentation) 
		fullFrame: (LayoutFrame identity) ! !

!GLMMorphicDynamicRenderer methodsFor: 'rendering' stamp: 'StephaneDucasse 1/9/2016 10:09'!
render: aPresentation
	container := GLMMorphic containerMorph.
	container 
		addMorph: (self renderObject: aPresentation currentPresentation) 
		fullFrame: (LayoutFrame identity).
	aPresentation when: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicLabelRenderer
	instanceVariableNames: 'labelMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicLabelRenderer methodsFor: 'rendering' stamp: 'TudorGirba 7/1/2011 23:18'!
actOnPresentationUpdated: anAnnouncement
	labelMorph contents: anAnnouncement presentation formatedDisplayValue! !

!GLMMorphicLabelRenderer methodsFor: 'rendering' stamp: 'StephaneDucasse 1/9/2016 10:09'!
render: aLabelPresentation
	labelMorph := (LabelMorph contents: aLabelPresentation formatedDisplayValue)
		layoutFrame: (LayoutFrame identity);
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		font: StandardFonts haloFont;
		yourself.
	aLabelPresentation when: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ labelMorph! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicListingRenderer
	instanceVariableNames: 'treeMorph treeModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicListingRenderer subclass: #GLMMorphicListRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicListingRenderer methodsFor: 'rendering' stamp: 'AndreiChis 11/3/2013 12:08'!
actOnContextChanged: anAnnouncement 
	anAnnouncement property = #selection ifTrue: [ 
		treeModel announcer 
			suspendAll: self suspendedAnnouncements
			while: [
				treeMorph model explicitSelection: anAnnouncement value ] ] ! !

!GLMMorphicListingRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/20/2012 15:18'!
actOnUpdatedPresentation: anAnnouncement
	treeMorph model updateRoots.
	self flag: 'Calling update list explicitly here is a hack. This should be solvable by the model through a notification mechanism'.
	treeMorph updateList! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'AndreiChis 3/28/2017 11:47'!
newTreeMorph

	^ GLMPaginatedMorphTreeMorph new! !

!GLMMorphicListingRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:20'!
render: aPresentation
	| container textInput |
	treeModel := GLMTreeMorphModel new glamourPresentation: aPresentation.
	container := GLMMorphic containerMorph.
	treeMorph := self treeMorphFor: treeModel and: aPresentation.
	aPresentation allowsInput
		ifTrue: [ 
			textInput := self textInputFor: treeModel withHelpMessage: aPresentation helpMessage.
			treeMorph layoutFrame bottomOffset: -26.
			container addMorphBack: textInput ].
	container addMorphBack: treeMorph.
	self installActionsOnModel: treeModel fromPresentation: aPresentation.
	self installKeystrokeActionsOnMorph: treeMorph fromPresentation: aPresentation.
	aPresentation selection notNil
		ifTrue: [ 
			treeModel announcer
				suspendAll: self suspendedAnnouncements
				while: [ treeMorph model explicitSelection: aPresentation selection ] ].	"When the morph changes, we want to update the glamour model"
	treeModel announcer
		when: GLMTreeMorphSelectionChanged
		do: [ :ann | 
			aPresentation announcer
				suspendAllWhile: [ 
					aPresentation selection: ann selectionValue.
					aPresentation selectionPath: ann selectionPathValue ] ].
	treeModel announcer
		when: GLMTreeMorphStrongSelectionChanged
		do: [ :ann | aPresentation strongSelection: ann strongSelectionValue ].	"When the glamour model changes, we want to update the morph"
	aPresentation when: GLMContextChanged send: #actOnContextChanged: to: self.
	aPresentation when: GLMPresentationUpdated send: #actOnUpdatedPresentation: to: self.
	^ container! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'AndreiChis 11/3/2013 11:48'!
suspendedAnnouncements
	^ OrderedCollection  
		with: GLMTreeMorphSelectionChanged 
		with: GLMTreeMorphStrongSelectionChanged 
		with: GLMMenuItemSelected 
		with: GLMKeyStroke! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'TudorGirba 2/24/2016 19:18'!
textInputFor: aTreeModel withHelpMessage: helpStringMessage
	| textInput |
	textInput := self theme
		newTextEntryIn: nil
		for: aTreeModel
		get: #inputText
		set: #inputText:
		class: String
		getEnabled: #inputTextEnabled
		help: helpStringMessage.
	textInput askBeforeDiscardingEdits: false.
	textInput ghostText: helpStringMessage.
	textInput layoutFrame: (LayoutFrame fractions: (0 @ 1 corner: 1 @ 1) offsets: (0 @ -26 corner: 0 @ -4)).
	^ textInput! !

!GLMMorphicListingRenderer methodsFor: 'private' stamp: 'TudorGirba 10/30/2016 10:24'!
treeMorphFor: tmpTreeModel and: aPresentation
	| tmpTreeMorph columns |
	tmpTreeMorph := self newTreeMorph.
	tmpTreeMorph
		makeLastColumnUnbounded;
		doubleClickSelector: #onDoubleClick;
		getMenuSelector: #menu:shifted:;
		keystrokeActionSelector: #keyStroke:from:;
		columnInset: 3;
		rowInset: 1;
		cornerStyle: tmpTreeMorph preferredCornerStyle;
		borderStyle: (BorderStyle inset width: 1);
		autoDeselection: aPresentation allowsDeselection;
		dragEnabled: tmpTreeModel dragEnabled;
		dropEnabled: tmpTreeModel dropEnabled;		
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		layoutFrame: (LayoutFrame identity).
	columns := aPresentation columns isEmpty 
		ifTrue: [ OrderedCollection with: (MorphTreeColumn new rowMorphGetSelector: #elementColumn)]
		ifFalse: [
			aPresentation columns collect: [:each | 
				GLMMorphTreeColumn new 
					startWidth: each width;
					glamourColumn: each; 
					headerButtonLabel: (aPresentation titleValueOfColumn: each)
					font: StandardFonts menuFont 
					target: tmpTreeModel
					actionSelector: #sortByColumn:
					arguments: {each}; 
					yourself ].
		].
	tmpTreeMorph
		preferedPaneColor: Smalltalk ui theme backgroundColor;	
		model: tmpTreeModel;
		columns: columns.
	aPresentation isMultiple 
		ifTrue: [tmpTreeMorph beMultiple] 
		ifFalse: [tmpTreeMorph beSingle].
	tmpTreeMorph chunkSize: aPresentation amountToShow.
	tmpTreeMorph pageSize: aPresentation amountToShow.
	tmpTreeMorph vShowScrollBar.
	tmpTreeMorph hShowScrollBar.
	^ tmpTreeMorph buildContents! !

GLMMorphicListingRenderer subclass: #GLMMorphicTableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTableRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 10/7/2014 12:48'!
render: aPresentation
	| container |
	container := super render: aPresentation.
	"aPresentation shouldAllExpand ifTrue: [treeMorph expandAll ]."
	aPresentation shouldRootsExpand ifTrue: [treeMorph expandRoots . treeMorph makeLastColumnBounded ].
	"aPresentation shouldExpandToLevel ifTrue: [ treeMorph expandAllTo: aPresentation expandLevel ]."
	^ container! !

GLMMorphicListingRenderer subclass: #GLMMorphicTreeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicTreeRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/9/2014 21:40'!
render: aPresentation
	| container |
	container := super render: aPresentation.
	aPresentation shouldAllExpand ifTrue: [treeMorph expandAll ].
	aPresentation shouldRootsExpand ifTrue: [treeMorph expandRoots ].
	aPresentation shouldExpandToLevel ifTrue: [ treeMorph expandAllTo: aPresentation expandLevel ].
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicMorphRenderer
	instanceVariableNames: 'scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicMorphRenderer methodsFor: 'rendering' stamp: 'EstebanLorenzano 11/8/2011 02:06'!
actOnKeyStroke: aPresentation event: anEvent from: aMorph 
	| action |

	anEvent commandKeyPressed ifFalse: [ ^self ].
	action := (self allKeyboardActionsFor: aPresentation) 
		detect: [ :each | each shortcut = anEvent keyCharacter  ] 
		ifNone: [ nil ].
		
	action 
		ifNotNil: [ action actOn: aPresentation].! !

!GLMMorphicMorphRenderer methodsFor: 'rendering' stamp: 'AndreiChis 8/14/2015 11:57'!
actOnPresentationUpdated: ann
	scrollPane scrollTarget: (self morphFrom: ann presentation)! !

!GLMMorphicMorphRenderer methodsFor: 'private' stamp: 'EstebanLorenzano 11/8/2011 00:22'!
allKeyboardActionsFor: aPresentation 
	^(aPresentation allActions, 
		aPresentation allSelectionActions) 
		select: [ :action | action hasShortcut ]! !

!GLMMorphicMorphRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/9/2014 14:49'!
morphFrom: aMorphPresentation
	| morph  |
	
	morph := aMorphPresentation morph 
		vResizing: #spaceFill; 
		hResizing: #spaceFill;
		yourself.
	
	(self allKeyboardActionsFor: aMorphPresentation) ifNotEmpty: [
		morph 
			on: #keyStroke 
			send: #actOnKeyStroke:event:from: 
			to: self 
			withValue: aMorphPresentation ].
		
	^morph! !

!GLMMorphicMorphRenderer methodsFor: 'rendering' stamp: 'AndreiChis 8/14/2015 11:56'!
render: aMorphPresentation
	aMorphPresentation when: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ (scrollPane := self scrollMorphFor: (self morphFrom: aMorphPresentation))! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicPaneRenderer
	instanceVariableNames: 'container contentMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'AndreHora 2/14/2014 16:52'!
actOnMatchingPresentationChanged: anAnnouncement
	container removeAllMorphs.
	self renderContainerFor: anAnnouncement pane.
	self renderer window
		ifNotNil: [ 
			self flag: 'this check is fishy'.
			self renderer window fullBounds ]! !

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 3/22/2015 11:48'!
actOnPresentationToolbarUpdated: anAnnouncement
	"If this method is called contentMorph should be an tab widget"
	| presentation |
	
	presentation := anAnnouncement presentation.	
	contentMorph updatePageAtIndex: 1
			withLabel: (self titleOrIconOf: presentation in: contentMorph)
			toolbar: (self renderToolbarForPresentation: presentation inMorph: contentMorph)
			action: (self labelActionBrickFor: presentation)
	
	! !

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:26'!
render: aPane
	container := GLMMorphic containerMorph.
	self renderContainerFor: aPane.
	aPane when: GLMMatchingPresentationsChanged send: #actOnMatchingPresentationChanged: to: self.
	(aPane presentations hasTitle or: [aPane presentations hasTitleIcon]) ifTrue: [
		aPane when: GLMPresentationToolbarUpdated send: #actOnPresentationToolbarUpdated: to: self. ].
	^ container! !

!GLMMorphicPaneRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 2/9/2017 14:25'!
renderContainerFor: aPane

	contentMorph := self 
		morph: (self renderObject: aPane presentations) 
		withTitleOrNilOf: aPane presentations.
		
	container
		addMorph: contentMorph fullFrame: (LayoutFrame identity);
		"adoptPaneColor: Color transparent"
		yourself! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicPaneWithoutTitleRenderer
	instanceVariableNames: 'container paneMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPaneWithoutTitleRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 12:31'!
actOnMatchingPresentationsChanged: anAnnouncement 
	paneMorph	removeAllMorphs.
	self renderMorphFor: anAnnouncement pane.
	self renderer window fullBounds! !

!GLMMorphicPaneWithoutTitleRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:44'!
render: aPane
	paneMorph := GLMMorphic containerMorph.
	aPane when: GLMMatchingPresentationsChanged send: #actOnMatchingPresentationsChanged: to: self.
	self renderMorphFor: aPane.
	^ paneMorph! !

!GLMMorphicPaneWithoutTitleRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 2/9/2017 14:25'!
renderMorphFor: aPane
	paneMorph
		addMorph: (self renderObject: aPane presentations) fullFrame: (LayoutFrame identity);
		"adoptPaneColor: paneMorph paneColor"
		yourself! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicRubricTextRenderer
	instanceVariableNames: 'textMorph textModel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicRubricTextRenderer subclass: #GLMMorphicPharoCodeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPharoCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 7/7/2014 22:16'!
actOnCompileText: ann 
	
	"The current compiler wants to notify a text morph object in case of errors. 
	The compilation is delagated to the renderer, as the renderer has access
	to the text morph object."
	(ann session 
		recompileMethodTo: ann presentation text 
		inContext: ann context 
		notifying: textMorph) ifTrue: [ ann action ifNotNil: [ :action | action value ] ]! !

!GLMMorphicPharoCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 1/30/2015 14:58'!
actOnEvaluateSelection: ann 

	"We get here as a result of an announcement.
	If we do not defer the execution and an exception is triggered by the execution of the code
	then resuming the execution in the debugger will trigger an error when unwinding the stack."
	ann isSyncronous ifTrue: [ 
		textMorph textArea editor evaluateSelectionAndDo: ann action.
		^ self ]. 
	UIManager default defer: [ 
		textMorph textArea editor evaluateSelectionAndDo: ann action ]
	! !

!GLMMorphicPharoCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 4/11/2015 21:39'!
actOnHighlightAndEvaluate: ann 

	"We get here as a result of an announcement.
	If we do not defer the execution and an exception is triggered by the execution of the code
	then resuming the execution in the debugger will trigger an error when unwinding the stack."
	UIManager default defer: [ 
		textMorph textArea handleEdit: [
			textMorph textArea editor highlightEvaluateAndDo: ann action .
			textMorph shoutStyler style: textMorph text. ] ]! !

!GLMMorphicPharoCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 4/11/2015 21:40'!
debugHighlightedText

	UIManager default defer: [ 
		textMorph textArea editor debugHighlight.
		textMorph shoutStyler style: textMorph text. ]
	! !

!GLMMorphicPharoCodeRenderer methodsFor: 'callbacks' stamp: 'AliakseiSyrel 11/2/2015 00:13'!
evaluateAndPopPrintHighlight

	GLMPrintPopper
		installAlarm: #popupPrint
		for: self! !

!GLMMorphicPharoCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 5/30/2014 14:33'!
evaluateAndPrintSelection

	UIManager default defer: [ 
		textMorph textArea editor printIt ]
	! !

!GLMMorphicPharoCodeRenderer methodsFor: 'rendering' stamp: 'AndreiChis 2/23/2017 18:15'!
modelFor: aPresentation
	| highlightContext |
	highlightContext := aPresentation highlightSmalltalkContext. 
	^ GLMRubricSmalltalkTextModel new
		glamourPresentation: aPresentation;
		highlightSmalltalk: highlightContext notNil;
		highlightSmalltalkContext: highlightContext;
		yourself! !

!GLMMorphicPharoCodeRenderer methodsFor: 'events-alarms' stamp: 'AliakseiSyrel 11/2/2015 00:14'!
popupPrint
	"Evaluates selected code and prints it in a popper"
	textMorph textArea editor highlightEvaluateAndDo: [ :result | 
		textMorph shoutStyler style: textMorph text.
		GLMPrintPopper new 
			openFromRubric: textMorph textArea withResult: result ]! !

!GLMMorphicPharoCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 4/11/2015 21:40'!
profileHighlightedText

	textMorph textArea editor tallyHighlight.
	textMorph shoutStyler style: textMorph text.! !

!GLMMorphicPharoCodeRenderer methodsFor: 'private' stamp: 'CyrilFerlicot 5/22/2015 14:29'!
registerEventsForPresentation: aPresentation
	super registerEventsForPresentation: aPresentation.
	aPresentation when: GLMSelectCurrentLine send: #selectLine to: self.
	aPresentation when: GLMEvaluateSelection send: #actOnEvaluateSelection: to: self.
	aPresentation when: GLMHighlightAndEvaluate send: #actOnHighlightAndEvaluate: to: self.
	aPresentation when: GLMCompileText send: #actOnCompileText: to: self.
	aPresentation when: GLMDebugSelection send: #debugHighlightedText to: self.
	aPresentation when: GLMProfileSelection send: #profileHighlightedText to: self.
	aPresentation when: GLMPrintSelection send: #evaluateAndPopPrintHighlight to: self! !

!GLMMorphicPharoCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 5/7/2014 18:01'!
selectLine
	
	textMorph textArea editor lineSelectAndEmptyCheck: [^ nil]! !

GLMMorphicPharoCodeRenderer subclass: #GLMMorphicPharoMethodRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPharoMethodRenderer methodsFor: 'private' stamp: 'AndreiChis 5/7/2014 17:28'!
methodBindingsStrategy

	^ [ :currentBindings :aSymbol |
		 currentBindings associationAt: aSymbol ifAbsent: [nil] ]! !

!GLMMorphicPharoMethodRenderer methodsFor: 'rendering' stamp: 'AndreiChis 3/3/2017 17:30'!
modelFor: aPresentation

	^ (super modelFor: aPresentation)
		bindingsStrategy: self methodBindingsStrategy;
		appendVariableBinding: aPresentation variableBindings;
		yourself! !

!GLMMorphicPharoMethodRenderer methodsFor: 'rendering' stamp: 'AndreiChis 3/5/2017 15:22'!
morph
	|morph|
	morph := RubScrolledTextMorph new
		beForSmalltalkCode;
		getSelectionSelector: #primarySelectionInterval;
		model: textModel;
		color: Smalltalk ui theme backgroundColor;
		textFont: StandardFonts codeFont;
		yourself.
	
	(morph textArea decoratorNamed: #shoutStyler) ifNotNil: [ :styler | 
		"In case a method presentation has variable bindings change the settings
		of the styler to take this into account: set the current model as a workspace
		in the styler and inform it the code represents a method."
		textModel glamourPresentation variableBindings ifNotEmpty: [
			styler styler 
				workspace: textModel;
				isForWorkspace: false. 
			styler refreshStyling] ].
	^ morph! !

GLMMorphicPharoCodeRenderer subclass: #GLMMorphicPharoScriptRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicPharoScriptRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 3/19/2015 17:37'!
actOnVariableBindingsAccessRequest: ann 

	ann action ifNotNil: [ :aBlock |
		aBlock cull: textModel variableBindings ]! !

!GLMMorphicPharoScriptRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 3/27/2015 17:38'!
actOnVariableBindingsUpdated: ann 

	textModel variableBindings: nil.
	textModel appendVariableBinding: ann presentation variableBindings.
	textMorph shoutStyler style: textMorph text.! !

!GLMMorphicPharoScriptRenderer methodsFor: 'rendering' stamp: 'AndreiChis 2/23/2017 18:15'!
modelFor: aPresentation

	^ (super modelFor: aPresentation)
		highlightSmalltalk: true;
		bindingsStrategy: self workspaceBindingsStrategy;
		appendVariableBinding: aPresentation variableBindings;
		yourself! !

!GLMMorphicPharoScriptRenderer methodsFor: 'rendering' stamp: 'AndreiChis 12/30/2016 15:56'!
morph
	|morph|
	morph := RubScrolledTextMorph new
		getSelectionSelector: #primarySelectionInterval;
		model: textModel;
		beForSmalltalkScripting;
		textFont: StandardFonts codeFont;
		color: Smalltalk ui theme backgroundColor;
		notificationStrategy: GLMPopperNotificationStrategy new;
		yourself.
	"Without forcing styling explicitly the first time the presentation is opened with some text on it the styling is wrong."
	(morph textArea decoratorNamed: #shoutStyler) ifNotNil: [ :styler | styler refreshStyling ].
	^ morph! !

!GLMMorphicPharoScriptRenderer methodsFor: 'private' stamp: 'CyrilFerlicot 5/22/2015 14:30'!
registerEventsForPresentation: aPresentation

	super registerEventsForPresentation: aPresentation.
	
	aPresentation when: GLMVariableBindingsChanged send: #actOnVariableBindingsUpdated: to: self.
	aPresentation when: GLMVariableBindingsAccessRequest send: #actOnVariableBindingsAccessRequest: to: self.
	! !

!GLMMorphicPharoScriptRenderer methodsFor: 'private' stamp: 'AndreiChis 4/28/2016 11:02'!
workspaceBindingsStrategy

	^ [ :currentBindings :aString :aTextModel |
		(aTextModel doItReceiver class allInstVarNames includes: aString) 
			ifTrue: [ nil ]
			ifFalse: [  	
				(currentBindings includesKey: aString)
					ifFalse: [currentBindings add: (WorkspaceVariable key: aString asSymbol) ].
				currentBindings associationAt: aString] ]! !

GLMMorphicRubricTextRenderer subclass: #GLMMorphicRubricHighlightedTextRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicRubricHighlightedTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 1/17/2016 22:56'!
morph
	| morph |
	
	morph := super morph.
	morph editingMode: textModel glamourPresentation editingMode.
	morph textFont: textModel glamourPresentation morphicFont.
	"Changing the editing mode makes the editor dirty."
	morph hasUnacceptedEdits: false.
	^ morph
		! !

!GLMMorphicRubricTextRenderer methodsFor: 'private' stamp: 'AlainPlantec 8/2/2013 18:23'!
actOnContextChanged: ann
	ann property = #selectionInterval
		ifTrue: [
			ann value notNil 
				ifTrue: [textMorph setSelection: ann value ]
				ifFalse: [textMorph setSelection: (1 to: 0)] ]! !

!GLMMorphicRubricTextRenderer methodsFor: 'private' stamp: 'AndreiChis 12/30/2016 18:13'!
actOnPresentationUpdated: ann 
	| anInterval |
	anInterval := ann presentation selectionInterval.
	textMorph setText: ann presentation formatedDisplayValue.
	textMorph setSelection: anInterval! !

!GLMMorphicRubricTextRenderer methodsFor: 'private' stamp: 'AndreiChis 1/11/2016 15:27'!
actOnTextEditorRequest: ann

	ann action value: textMorph textArea editor 	
! !

!GLMMorphicRubricTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 6/3/2013 23:47'!
modelFor: aPresentation
	^ GLMRubricTextModel new
		glamourPresentation: aPresentation;
		yourself! !

!GLMMorphicRubricTextRenderer methodsFor: 'rendering' stamp: 'AndreiChis 1/18/2016 10:31'!
morph
	^ RubScrolledTextMorph new
		getSelectionSelector: #primarySelectionInterval;
		color: Smalltalk ui theme backgroundColor;
		textColor: Smalltalk ui theme  textColor;
		textFont: StandardFonts defaultFont;
		model: textModel;
		yourself.! !

!GLMMorphicRubricTextRenderer methodsFor: 'private' stamp: 'CyrilFerlicot 5/22/2015 14:28'!
registerEventsForPresentation: aPresentation
	aPresentation when: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	aPresentation when: GLMContextChanged send: #actOnContextChanged: to: self.
	aPresentation when: GLMTextEditorRequest send: #actOnTextEditorRequest: to: self! !

!GLMMorphicRubricTextRenderer methodsFor: 'rendering' stamp: 'JurajKubelka 2/17/2017 00:21'!
render: aPresentation
	textModel := self modelFor: aPresentation.
	textModel primarySelectionInterval: (aPresentation primarySelectionInterval 
		ifNil:[ aPresentation selectionInterval ifNil: [1 to: 0] ]).
	textMorph := self morph.
	aPresentation text: textMorph text.
	aPresentation withLineNumbers
		ifTrue: [ textMorph withLineNumbers ]
		ifFalse: [ textMorph withoutLineNumbers ].
	aPresentation withAnnotation
		ifTrue: [ textMorph withAnnotation ]
		ifFalse: [ textMorph withoutAnnotation ].
	aPresentation withColumns 
		ifTrue: [ textMorph withColumns ]
		ifFalse: [ textMorph withoutColumns ].
	textMorph wrapped: aPresentation wrapped.
	textMorph tabWidth: aPresentation tabWidth.
	aPresentation withGhostText ifNotNil: [ 
		textMorph withGhostText: aPresentation withGhostText asStringOrText ].
	aPresentation textSegments do: [:each | 
			textMorph addSegment: each ].
	(aPresentation textSegments anySatisfy: [ :ts | ts icon notNil ])
		ifTrue: [ textMorph withTextSegmentIcons ]
		ifFalse: [ textMorph withoutTextSegmentIcons ].
	textMorph textArea announcer
		when: RubTextChanged
		do: [ :ann | 
			aPresentation announcer
				suspendAllWhile: [ aPresentation text: textMorph text ] ].
	textMorph textArea announcer
		when: RubSelectionChanged
		do: [ :ann | 
			aPresentation announcer 
				suspendAllWhile: [ 
					aPresentation selectionInterval: textMorph selectionInterval.
					aPresentation selectedText: textMorph textArea selection ] ].
			
	textMorph textArea announcer
		when: RubTextAccepted
		do: [ :ann | aPresentation suspendAllWhile: [ aPresentation text: ann text ] ].
		
	self installActionsOnModel: textModel fromPresentation: aPresentation .
	self installKeystrokeActionsOnMorph: textMorph textArea fromPresentation: aPresentation.
	
	self registerEventsForPresentation: aPresentation.
	
	^ textMorph! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicSpecRenderer
	instanceVariableNames: 'container'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicSpecRenderer methodsFor: 'rendering' stamp: 'TudorGirba 4/3/2013 17:00'!
actOnPresentationUpdated: ann
	container removeAllMorphs.
	container addMorphBack: (self morphFrom: ann presentation)! !

!GLMMorphicSpecRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:45'!
render: aPresentation
	container := GLMMorphic containerMorph.
	container
		changeTableLayout;
		listDirection: #leftToRight;
		vResizing: #spaceFill;
		hResizing: #spaceFill.
	container addMorphBack: aPresentation displayValue widget widget.
	aPresentation when: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	^ container! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicTextRenderer
	instanceVariableNames: 'textModel textMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

GLMMorphicTextRenderer subclass: #GLMMorphicSmalltalkCodeRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 7/7/2014 22:16'!
actOnCompileText: ann 
	
	"The current compiler wants to notify a text morph object in case of errors. 
	The compilation is delagated to the renderer, as the renderer has access
	to the text morph object."
(ann session 
		recompileMethodTo: ann presentation text 
		inContext: ann context 
		notifying: textMorph) ifTrue: [ ann action ifNotNil: [ :action | action value ] ]
	! !

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 5/6/2014 15:13'!
actOnEvaluateSelection: ann 

	"We get here as a result of an announcement.
	If we do not defer the execution and an exception is triggered by the execution of the code
	then resuming the execution in the debugger will trigger an error when unwinding the stack."
	UIManager default defer: [ 
		textMorph evaluateSelectionAndDo: ann action ]! !

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 3/6/2014 12:14'!
actOnVariableBindingsUpdated: ann 

	textModel variableBindings: nil.
	self addVariableBindingsOn: textModel from: ann presentation.
	textModel changed: #text. self flag: 'update just the style here'! !

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'rendering' stamp: 'AndreiChis 3/6/2014 12:14'!
addVariableBindingsOn: aTextModel from: aPresentation

	aPresentation variableBindings do: [ :each | aTextModel addVariableBinding: each ].! !

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 5/7/2014 11:22'!
debugSelection

	textMorph debugIt! !

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 11/13/2014 14:50'!
evaluateAndPrintSelection

	UIManager default defer: [ textMorph printIt ]! !

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'callbacks' stamp: 'AndreiChis 5/6/2014 11:28'!
profileSelection

	textMorph tallyIt! !

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:45'!
registerEventsForPresentation: aPresentation
	super registerEventsForPresentation: aPresentation.
	aPresentation when: GLMVariableBindingsChanged send: #actOnVariableBindingsUpdated: to: self.
	aPresentation when: GLMEvaluateSelection send: #actOnEvaluateSelection: to: self.
	aPresentation when: GLMCompileText send: #actOnCompileText: to: self.
	aPresentation when: GLMDebugSelection send: #debugSelection to: self.
	aPresentation when: GLMProfileSelection send: #profileSelection to: self.
	aPresentation when: GLMPrintSelection send: #evaluateAndPrintSelection to: self! !

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'rendering' stamp: 'AndreiChis 5/6/2014 14:00'!
textModelFor: aPresentation
	| tm |
	tm := GLMSmalltalkCodeModel new
		text: aPresentation formatedDisplayValue;
		glamourPresentation: aPresentation;
		highlightSmalltalk: true;
		highlightSmalltalkContext: aPresentation highlightSmalltalkContext.
	self addVariableBindingsOn: tm from: aPresentation.
	aPresentation isForScripting ifTrue: [ 
		tm bindingsStrategy: self workspaceBindingsStrategy ].
	^ tm! !

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'rendering' stamp: 'StephaneDucasse 1/9/2016 10:08'!
textMorphForModel: aTextModel
	| morph  |
	morph := GLMPluggableTextMorph new.
	morph styler workspace: aTextModel.
	morph
		on: aTextModel
			text: #text
			accept: #accept:notifying:
			readSelection: #selection
			menu: #menu:shifted:;
		changedAction: [:aText| 
			aText asString trimBoth ifNotEmpty:  [aTextModel text: aText] ];
		onKeyStrokeSend: #keystroke:from: to: aTextModel;
		layoutFrame: (LayoutFrame identity);
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		color: Smalltalk ui theme backgroundColor;
		font: StandardFonts codeFont;
		yourself.
	^ morph! !

!GLMMorphicSmalltalkCodeRenderer methodsFor: 'private' stamp: 'AndreiChis 9/30/2014 15:24'!
workspaceBindingsStrategy

	^ [ :currentBindings :aString |
		(currentBindings includesKey: aString)
			ifFalse: [currentBindings add: (WorkspaceVariable key: aString asSymbol) ].
		currentBindings associationAt: aString]! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/10/2014 06:38'!
actOnContextChanged: ann 
	ann property = #selectionInterval
		ifTrue: [ 
			ann value notNil 
				ifTrue: [textMorph setSelection: ann value ]
				ifFalse: [textMorph setSelection: (1 to: 0)] ].
"	self flag: 'somehow this disturbs copy paste and cmd+shift+left selection'.
	ann property = #text
		ifTrue: [ 
			textMorph announcer suspendAll: {GLMTextChanged} while: [ 
					textModel changedText: ann value ] ]"! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 6/3/2013 08:21'!
actOnPresentationUpdated: ann 
	textModel text: ann presentation formatedDisplayValue.
	textModel changed: #text! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:45'!
registerEventsForPresentation: aPresentation
	aPresentation when: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	aPresentation when: GLMContextChanged send: #actOnContextChanged: to: self.
	aPresentation when: GLMSelectCurrentLine send: #selectLine to: self! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:45'!
render: aPresentation
	textModel := self textModelFor: aPresentation.
	textMorph := self textMorphForModel: textModel.	"this is a horrible hack: 
	because we cannot get the update of when the text changes from the morph,
	we get the reference to the mutable text object :) :)"
	textModel text: textMorph text.
	textMorph setSelection: textModel selection.	"Without setting the selection again 
	the smalltalkcode presentation shows no selection. Seems to be cause by the font: 
	message send when creating a GLMPluggableTextMorph"
	self installActionsOnModel: textModel fromPresentation: aPresentation.
	self installKeystrokeActionsOnMorph: textMorph textMorph fromPresentation: aPresentation.
	textMorph announcer
		when: GLMSelectedTextChanged
		do: [ :ann | 
			aPresentation announcer
				suspendAllWhile: [ 
					aPresentation selectionInterval: ann interval.
					aPresentation selectedText: ann selectedText ] ].
	textMorph announcer when: GLMTextChanged do: [ :ann | aPresentation suspendAllWhile: [ aPresentation text: ann text ] ].
	self registerEventsForPresentation: aPresentation.
	^ textMorph! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'AndreiChis 2/27/2014 17:23'!
selectLine
	
	textMorph selectLine! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'TudorGirba 9/20/2011 23:39'!
textModelFor: aPresentation
	^ GLMTextModel new
		text: aPresentation formatedDisplayValue;
		glamourPresentation: aPresentation! !

!GLMMorphicTextRenderer methodsFor: 'rendering' stamp: 'StephaneDucasse 1/9/2016 10:08'!
textMorphForModel:  aTextModel
	^ (GLMPluggableTextMorph
		on: aTextModel
		text: #text
		accept: #accept:notifying:
		readSelection: #selection
		menu: #menu:shifted:)
		changedAction: [:aText|
			aText asString trimBoth ifNotEmpty:  [aTextModel text: aText] ];
		onKeyStrokeSend: #keystroke:from: to: aTextModel;
		layoutFrame: (LayoutFrame identity);
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		color: Smalltalk ui theme backgroundColor;
		detachAllKeymapCategories;
		yourself! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicValidatorPaneRenderer
	instanceVariableNames: 'container paneMorph buttons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'cyrilledelaunay 3/23/2011 14:06'!
actOnMatchingPresentationsChanged: anAnnouncement 
	paneMorph	removeAllMorphs.
	self renderMorphFor: anAnnouncement pane.
	self renderer window fullBounds! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'AndreiChis 10/9/2014 17:27'!
buttonRowFrom: aCollectionOfButtons
	"Answer a new ok/cancel button row."

	|answer curentButtons e|
	curentButtons := aCollectionOfButtons.
	e := 0@0.
	curentButtons do: [:b | e := e max: b minExtent].
	curentButtons do: [:b | b extent: e].
	answer := Morph new
		color: Color transparent;
		changeTableLayout;
		cellInset: 8;
		listDirection: #leftToRight;
		listCentering: #bottomRight;
		hResizing: #spaceFill;
		vResizing: #shrinkWrap.
	curentButtons do: [:b | answer addMorphBack: b].
	^answer

	! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/23/2011 14:11'!
buttons

	^ buttons! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'accessing' stamp: 'cyrilledelaunay 3/23/2011 14:12'!
buttons: aCollectionOfButtons

	buttons := aCollectionOfButtons! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 2/9/2017 15:11'!
newColumnWith: aCollectionOfMorphElements
	"use this method to create a new column in your block"
	<lint: 'Utility methods' rationale: 'defined here to facilate the use of the library' author: 'cyrille.delaunay'>
	
	|answer|
	answer := GLMPanelMorph new
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		fillStyle: Color transparent; "non pane color tracking"
		changeTableLayout;
		cellInset: 8; yourself.
	aCollectionOfMorphElements do: [:m | answer addMorphBack: m].
	^answer! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:46'!
render: aPane
	paneMorph := GLMMorphic containerMorph.
	aPane when: GLMMatchingPresentationsChanged send: #actOnMatchingPresentationsChanged: to: self.
	self renderMorphFor: aPane.
	^ paneMorph! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 2/9/2017 14:25'!
renderCompositiePresentation: aCompositePresentation
	
	paneMorph := GLMMorphic containerMorph.
	paneMorph
		addMorph: 
			(self newColumnWith:  { (self renderObject: aCompositePresentation).  (self buttonRowFrom: self buttons) }) 
			fullFrame: (LayoutFrame identity);
		"addMorphBack: (self buttonRowFrom: self buttons)  ;  "
		"adoptPaneColor: paneMorph paneColor."
		yourself.
	
	^ paneMorph! !

!GLMMorphicValidatorPaneRenderer methodsFor: 'rendering' stamp: 'AliakseiSyrel 2/9/2017 14:25'!
renderMorphFor: aPane

	paneMorph
		addMorph: 
			("self newColumnWith:  {" (self renderObject: aPane presentations)".  (self buttonRowFrom: self buttons) }") 
			fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0.90));
		addMorph:  (self buttonRowFrom: self buttons)
			fullFrame: (LayoutFrame fractions: (0 @ 0.93 corner: 1 @ 1));
		"adoptPaneColor: paneMorph paneColor"
		yourself! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicWatcherRenderer
	instanceVariableNames: 'process'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWatcherRenderer commentStamp: '<historical>' prior: 0!
This is a special widget renderer in that it will get to render multiple panes on the same container morph provided by a unique instance of the GLMWatcherWindow.!

!GLMMorphicWatcherRenderer methodsFor: 'rendering' stamp: 'TudorGirba 5/28/2012 14:41'!
actOnMatchingPresentationsChanged: anAnnouncement
	"whenever a relevant pane changes its presentations,
	we override the contents from the GLMWatcherWindow"
	
	GLMWatcherWindow uniqueInstance 
		addContent: [ self renderObject: anAnnouncement pane presentations ]! !

!GLMMorphicWatcherRenderer methodsFor: 'rendering' stamp: 'CyrilFerlicot 5/22/2015 14:46'!
render: aPane
	"we just register for the announcement"

	aPane when: GLMMatchingPresentationsChanged send: #actOnMatchingPresentationsChanged: to: self! !

!GLMMorphicWidgetRenderer class methodsFor: 'instance creation' stamp: 'tg 8/22/2010 20:20'!
render: aPresentation from: aRenderer
	^ self new 
		renderer: aRenderer;
		render: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'AndreiChis 3/25/2015 13:50'!
dropDownMenuFrom: aBlock withIcon: anIcon
	| activeForm passiveForm menuButton | 
	
	activeForm := anIcon.
	passiveForm := anIcon.
	menuButton := MultistateButtonMorph new extent: activeForm extent.
	^ menuButton
		extent: activeForm extent;
				activeEnabledOverUpFillStyle: (ImageFillStyle form: activeForm);
				passiveEnabledOverUpFillStyle: (ImageFillStyle form: activeForm);
				activeEnabledOverDownFillStyle: (ImageFillStyle form: passiveForm);
		passiveEnabledOverDownFillStyle: (ImageFillStyle form: passiveForm);
		addUpAction: aBlock;
		setBalloonText: 'Menu' translated;
		yourself

! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 3/24/2013 21:58'!
installActionsOnModel: aMorphicModel fromPresentation: aPresentation 
	aMorphicModel when: GLMMenuItemSelected do: [ :ann | ann action morphicActOn: aPresentation ].
	aMorphicModel when: GLMKeyStroke do: [ :ann | ann action actOn: aPresentation ].! !

!GLMMorphicWidgetRenderer methodsFor: 'rendering' stamp: 'TudorGirba 7/1/2014 10:44'!
installKeystrokeActionsOnMorph: aMorph fromPresentation: aPresentation
	aPresentation allActionsWithShortcuts do: [ :each |
		each installKeyCombinationForPresentation: aPresentation onMorph: aMorph ]! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'AliakseiSyrel 3/22/2015 11:52'!
labelActionBrickFor: aPresentation
	
	 ^ aPresentation titleAction 
		ifNil: [ nil ]
		ifNotNil: [ :labelAction |
			((labelAction isAvailableOn: aPresentation) and: [ labelAction hasIcon ])
				ifTrue: [
					GLMActionButtonBrick new
						icon: labelAction icon;
						setBalloonText: labelAction title;
						action: [ labelAction actOn: aPresentation ] ]
				ifFalse: [ nil ] ]
	! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 10/12/2014 10:52'!
labelActionMorphFor: aPresentation
	
	 ^ aPresentation titleAction 
		ifNil: [ nil ]
		ifNotNil: [ :labelAction |
			((labelAction isAvailableOn: aPresentation) and: [ labelAction hasIcon ])
				ifTrue: [ 
					MultistateButtonMorph new
						extent: labelAction icon extent;
						activeEnabledOverUpFillStyle: (ImageFillStyle form: labelAction icon);
						setBalloonText: labelAction title;
						addUpAction: [ labelAction actOn: aPresentation ] ]
				ifFalse: [ nil ] ]
	! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'EstebanLorenzano 6/17/2016 11:24'!
menuIn: aMenuMorph for: aPresentation
	| subMenus targetMenuMorph subMenu |
	subMenus := Dictionary new.
	(aPresentation allActions select: [:each | each isMenu ]) do: [ :action |
		targetMenuMorph := action category notNil 
			ifTrue: [ subMenus at: action category ifAbsentPut: [ 
					subMenu :=  MenuMorph new.
					aMenuMorph add: action category subMenu: subMenu.
					subMenu ] ]
			ifFalse: [ aMenuMorph ].
		(targetMenuMorph 
			add: action title
			target: action 
			selector: #morphicActOn:
			argument: aPresentation)
			enabled: (action isEnabledOn: aPresentation);
			icon:  action icon;
			keyText: (action hasShortcut 
				ifTrue: [ action shortcutAsString ]
				ifFalse: [ nil ]) ].
	^ aMenuMorph! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'EstebanLorenzano 6/17/2016 11:26'!
moreToolbarActions: noIconActions on: aBrowser
	| menuMorph |
	menuMorph := MenuMorph new.
	noIconActions do: [ :each | 
		(menuMorph 
			add: each title
			target: each
			selector: #actOn:
			argument: aBrowser)
			enabled: (each isEnabledOn: aBrowser);
 			yourself].
	^ menuMorph! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'AliakseiSyrel 2/9/2017 15:06'!
morph: aMorph withTitleOf: aPresentation	
	| tabs |
	tabs := LazyTabGroupMorph new.
	tabs
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		cornerStyle: (self theme tabGroupCornerStyleIn: nil);
		font: self theme labelFont.
	self flag: 'add a regular page instead of a lazy one'.
	self flag: 'handle the PresentationChanged announcement to update the label in the morph. 
	The problem is that at the moment I do not know how to link to the label in the tabSelectorMorph'.
	tabs 
		addLazyPage: aMorph
		label: (self titleOrIconOf: aPresentation in: tabs)
		toolbar: (self renderToolbarForPresentation: aPresentation inMorph: aMorph)
		action: (self labelActionBrickFor: aPresentation).
	tabs selectedPageIndex: 1.
	^ tabs! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:19'!
morph: aMorph withTitleOrNilOf: aPresentation
	(aPresentation hasTitle or: [aPresentation hasTitleIcon]) ifFalse: [
		"we render at least the toolbar"
		^ self morph: aMorph withToolbarOf: aPresentation ].
	^ self morph: aMorph withTitleOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:21'!
morph: aMorph withToolbarOf: aPresentation
	| container offset dock |
	aPresentation hasActions ifFalse: [ ^ aMorph ].
	container := GLMMorphic containerMorph.
	offset := 0.
	dock := self renderToolbarForPresentation: aPresentation inMorph: container.
	offset := dock minExtent y.
	container addMorph: dock fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 0) offsets: (0 @ 0 corner: 0 @ offset)).	
	container 
		addMorph: aMorph 
		fullFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ offset corner: 0 @ 0)).
	^ container! !

!GLMMorphicWidgetRenderer methodsFor: 'rendering' stamp: 'tg 8/22/2010 20:17'!
render: aPresentation
	^ self subclassResponsibility ! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/5/2011 23:47'!
renderObject: anObject
	^ self renderer render: anObject ! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/10/2016 17:25'!
renderToolbarForPresentation: aPresentation inMorph: aMorph
	| dock buttons |
	
	dock := aMorph theme newToolDockingBarIn: aMorph.
	buttons := self toolbarButtonsForPresentation: aPresentation.
	dock addAllMorphs: buttons.
	(aPresentation allActions select: #isMenu) ifNotEmpty: [
			dock addMorphBack: (self 
				dropDownMenuFrom: [ | menu |
					menu := self menuIn: MenuMorph new for: aPresentation.
					menu popUpEvent: self currentEvent in: aMorph world ]
				withIcon: GLMUIThemeExtraIcons glamorousMore)].
	^ dock! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/28/2011 19:20'!
renderWithTitle: aPresentation
	| morph |
	morph := self renderObject: aPresentation.
	^ self morph: morph withTitleOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:19'!
renderWithTitleOrNil: aPresentation
	| morph |
	morph := self renderObject: aPresentation.
	^ self morph: morph withTitleOrNilOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 1/31/2011 02:20'!
renderWithToolbar: aPresentation
	| presentationMorph |
	presentationMorph := self renderObject: aPresentation.
	^ self morph: presentationMorph withToolbarOf: aPresentation! !

!GLMMorphicWidgetRenderer methodsFor: 'accessing' stamp: 'TudorGirba 1/5/2011 23:42'!
renderer
	^ renderer ifNil: [renderer := GLMMorphicRenderer new]! !

!GLMMorphicWidgetRenderer methodsFor: 'accessing' stamp: 'tg 8/22/2010 20:20'!
renderer: anObject
	renderer := anObject! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'SeanDeNigris 8/1/2015 09:44'!
scrollMorphFor: aMorph
	^ GeneralScrollPane new
			changeScrollerTableLayout;
			scrollTarget: aMorph;
			layoutFrame: (LayoutFrame fractions: (0 @ 0 corner: 1 @ 1) offsets: (0 @ 25 corner: 0 @ 0));
			yourself
	! !

!GLMMorphicWidgetRenderer methodsFor: 'factory' stamp: 'tg 8/23/2010 00:02'!
theme
	^ UITheme current! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'AliakseiSyrel 3/22/2015 18:13'!
titleOrIconOf: aPresentation in: container
	^ aPresentation hasTitleIcon 
		ifTrue: [
			| image |
			image := GLMInteractableBrick new
						normalImage: aPresentation titleIconValue.
			image maxWidth: [ aPresentation titleIconValue width * 2 ].
			image hSpaceFill.
			image vSpaceFill.
			aPresentation titleValue ifNotNil: [
				image setBalloonText: aPresentation titleValue maxLineLength: 100 ].
			image  ]
		ifFalse: [ aPresentation titleValue ifNil: [''] ]! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'TudorGirba 4/14/2011 23:59'!
titleOrIconOrNilOf: aPresentation in: container
	^ aPresentation hasTitleIcon 
		ifTrue: [
			| image |
			image := self theme 
					newImageIn: container
					form: aPresentation titleIconValue.
			aPresentation titleValue isNil ifFalse: [
				image setBalloonText: aPresentation titleValue maxLineLength: 10 ]  ]
		ifFalse: [ 
			aPresentation hasTitle 
				ifTrue: [ aPresentation titleValue ]
				ifFalse: [ nil ] ]! !

!GLMMorphicWidgetRenderer methodsFor: 'private' stamp: 'AndreiChis 3/25/2015 13:19'!
toolbarButtonsForPresentation: aPresentation

	^ (aPresentation allActions select: [:each | each isButton ]) 
		collect: [:each | |actionMorph|
			actionMorph := (each renderGlamorouslyOn: self renderer).
			actionMorph arguments 
				ifNil: [ actionMorph arguments: { aPresentation } ]
				ifNotNil: [ actionMorph arguments: ({ aPresentation }, actionMorph arguments) ].
			actionMorph ].
	! !

GLMMorphicWidgetRenderer subclass: #GLMMorphicWindowRenderer
	instanceVariableNames: 'window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMMorphicWindowRenderer commentStamp: '<historical>' prior: 0!
This renders the top most browser or composite presentation in a window.!

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'AndreiChis 1/25/2017 16:03'!
actOnPresentationToolbarUpdated: ann
	| dock |

	self setLabelOf: window for: ann presentation.
	dock := self renderToolbarForPresentation: ann presentation inMorph: window.
	dock hResizing: #shrinkWrap.
	window toolbarBox: dock.! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/15/2011 11:23'!
actOnPresentationUpdated: ann
		self setLabelOf: window for: ann presentation! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'TudorGirba 3/3/2013 21:52'!
handlePotentialStatusbarFor: aRenderable
	| statusbarMorph bottomOffset |
	bottomOffset := 0.
	aRenderable hasStatusbar
		ifTrue: [ 
			statusbarMorph := GLMMorphicPaneWithoutTitleRenderer render: aRenderable statusbarPane from: self renderer.
			bottomOffset := (0 - (LabelMorph contents: 'XXX') minHeight) * 1.2.
			window
				addMorph: statusbarMorph
				fullFrame: (LayoutFrame fractions: (0 @ 1 corner: 1 @ 1) offsets: (2 @ bottomOffset corner: -2 @ 0)) ].
	^ bottomOffset! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'AndreiChis 1/25/2017 15:51'!
render: aRenderable
	| dock offset bottomOffset |
	window := GLMSystemWindow new model: aRenderable.
	self installActionsOnModel: window fromPresentation: aRenderable.
	self installKeystrokeActionsOnMorph: window fromPresentation: aRenderable.
	self setLabelOf: window for: aRenderable.
	offset := 4.
	bottomOffset := 0.
	dock := self renderToolbarForPresentation: aRenderable inMorph: window.
	dock hResizing: #shrinkWrap.
	window toolbarBox: dock.
	bottomOffset := self handlePotentialStatusbarFor: aRenderable.
	window
		addMorph: (self renderObject: aRenderable)
		fullFrame: ((0 @ 0 corner: 1 @ 1) asLayoutFrame 
						topLeftOffset: 0 @ offset ; 
						bottomRightOffset: 0@ bottomOffset).
	self setPotentialBackgroundColorFor: aRenderable.
	aRenderable when: GLMPresentationUpdated send: #actOnPresentationUpdated: to: self.
	aRenderable when: GLMPresentationToolbarUpdated send: #actOnPresentationToolbarUpdated: to: self.
	aRenderable when: GLMWindowRequest send: #actOnWindowRequest: to: window.
	aRenderable watcherPane notNil
		ifTrue: [ GLMMorphicWatcherRenderer render: aRenderable watcherPane from: self renderer ].
	^ window! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'AndreiChis 3/25/2015 14:04'!
renderToolbarForPresentation: aPresentation inMorph: aMorph
	| dock buttons |
	dock := aMorph theme newToolDockingBarIn: aMorph.
	buttons := self toolbarButtonsForPresentation: aPresentation.
	dock addAllMorphs: buttons.
	dock addMorphBack: (self 
		dropDownMenuFrom: [ | menu defaultMenu |
				defaultMenu := aMorph buildWindowMenu.
				(aPresentation allActions select: #isMenu) ifNotEmpty: [ 
					defaultMenu addLine ].
				menu := self menuIn: defaultMenu for: aPresentation.
				menu popUpEvent: self currentEvent in: aMorph world ]
		withIcon: aMorph theme windowMenuForm).
	^ dock! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'AndreiChis 10/9/2014 17:41'!
setLabelOf: aWindow for: aRenderable
	aWindow setLabel: (self titleFor: aRenderable).! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'TudorGirba 2/11/2014 06:39'!
setPotentialBackgroundColorFor: aRenderable
	aRenderable colorValue ifNotNil: [ window borderColor: aRenderable colorValue ]! !

!GLMMorphicWindowRenderer methodsFor: 'rendering' stamp: 'tg 8/24/2010 22:04'!
titleFor: aRenderable
	^ aRenderable titleValue ifNil: [ 'Glamorous Browser' ]! !

!GLMSpawnBrowserAction methodsFor: '*glamour-morphic-renderer' stamp: 'cyrilledelaunay 8/9/2011 13:57'!
morphicActOn: aPresentation

	^ (self actOn: aPresentation) open! !

Notification subclass: #GLMSingleSpotterRequest
	instanceVariableNames: 'prompt default assisted searchBlock labelBlock iconBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMSingleSpotterRequest class methodsFor: 'utilities' stamp: 'ML 2/26/2011 15:02'!
substring: testString matches: aString caseSensitive: aBoolean
	"Checks if a testString is a substring of aString. The matching parts do not necessarily need to be consecutive, for example 'egli' matches 'renggli'."

	| index |
	index := 0.
	testString do: [ :char |
		index := aString
			findString: (String with: char)
			startingAt: index + 1
			caseSensitive: aBoolean.
		index = 0
			ifTrue: [ ^ false ] ].
	^ true! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
assisted
	^ assisted! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
assisted: aBoolean
	"A boolean indicating that the typing of the user is assisted but not constrained."
	
	assisted := aBoolean! !

!GLMSingleSpotterRequest methodsFor: 'configuration' stamp: 'ML 2/26/2011 15:02'!
collection: aCollection
	self collection: aCollection caseSensitive: false! !

!GLMSingleSpotterRequest methodsFor: 'configuration' stamp: 'ML 2/26/2011 15:02'!
collection: aCollection caseSensitive: aBoolean
	"Configure this completion dialog with aCollection and match the elements case sensitive if aBoolean is true. Display the complete list if the filter is empty."

	self searchBlock: [ :value |
		value isEmpty
			ifTrue: [ aCollection ]
			ifFalse: [
				aCollection select: [ :each |
					self class
						substring: value
						matches: (self labelFor: each)
						caseSensitive: aBoolean ] ] ]! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
default
	^ default! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
default: aString
	"The default string initially used for filtering."
	
	default := aString! !

!GLMSingleSpotterRequest methodsFor: 'initialize-release' stamp: 'TudorGirba 10/26/2011 16:01'!
defaultAction
	^(GLMMorphicSingleSpotter openOn: self) answer! !

!GLMSingleSpotterRequest methodsFor: 'dispatching' stamp: 'ML 2/26/2011 15:02'!
handleWith: anObject
	^ anObject handleCompletionRequest: self! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
iconBlock
	^ iconBlock! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
iconBlock: aOneArgumentBlock
	"A one argument block answering the icon symbol for a given element."
	
	iconBlock := aOneArgumentBlock! !

!GLMSingleSpotterRequest methodsFor: 'querying' stamp: 'ML 2/26/2011 15:02'!
iconFor: anObject
	^ iconBlock value: anObject! !

!GLMSingleSpotterRequest methodsFor: 'initialization' stamp: 'ML 2/26/2011 15:02'!
initialize
	super initialize.
	prompt := 'Completion Request'.
	default := String new.
	assisted := false.
	searchBlock := [ :value | #() ].
	labelBlock := [ :value | value asString ].
	iconBlock := [ :value | nil ]! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
labelBlock
	^ labelBlock! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
labelBlock: aOneArgumentBlock
	"A one argument block answering the string for a given element."
	
	labelBlock := aOneArgumentBlock! !

!GLMSingleSpotterRequest methodsFor: 'querying' stamp: 'ML 2/26/2011 15:02'!
labelFor: anObject
	^ labelBlock value: anObject! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:56'!
name
	^self prompt! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
prompt
	^ prompt! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
prompt: aString
	"A string with the title for this request."
	
	prompt := aString! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
searchBlock
	^ searchBlock! !

!GLMSingleSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 15:02'!
searchBlock: aOneArgumentBlock
	"A one argument block returning the elements for the given filter."
	
	searchBlock := aOneArgumentBlock! !

!GLMSingleSpotterRequest methodsFor: 'querying' stamp: 'ML 2/26/2011 15:02'!
valuesFor: anObject
	^ searchBlock value: anObject! !

Notification subclass: #GLMSpotterRequest
	instanceVariableNames: 'requests prompt default'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'ML 2/26/2011 16:07'!
add: aRequest
	requests add: aRequest ! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:20'!
default
	^ default! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:20'!
default: anObject
	default := anObject! !

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'TudorGirba 2/27/2011 15:25'!
defaultAction
	^(GLMMorphicSpotter openOn: self) answer! !

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'ML 2/26/2011 16:10'!
handleWith: anObject
	^ anObject handleCompletionRequest: self! !

!GLMSpotterRequest methodsFor: 'initialize-release' stamp: 'ML 2/26/2011 16:08'!
initialize
	super initialize.
	requests := OrderedCollection new.! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:19'!
prompt
	^ prompt! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:19'!
prompt: anObject
	prompt := anObject! !

!GLMSpotterRequest methodsFor: 'accessing' stamp: 'ML 2/26/2011 16:29'!
requests
	^requests ! !

TestCase subclass: #GLMMorphicSpotterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMMorphicSpotterTest methodsFor: 'as yet unclassified' stamp: 'DamienCassou 12/3/2012 18:15'!
creation
	| composite classRequest methodRequest thirdRequest |
	composite  := GLMSpotterRequest new.

	classRequest := GLMSingleSpotterRequest new 
			prompt: 'Find Class';
			searchBlock: [ :string | Smalltalk allClassesAndTraits select: [:each | string, '*' match: each name] ];
			labelBlock: [ :class | class name ]";
			iconBlock: [ :class | class browserIcon ]".

	methodRequest := GLMSingleSpotterRequest new 
			prompt: 'Object Selectors';
			searchBlock: [ :string | Object selectors select: [:e| string, '*' match: e asString] ];
			labelBlock: [ :e | e ].

	thirdRequest := GLMSingleSpotterRequest new 
			prompt: 'Other Selectors';
			searchBlock: [ :string | Class selectors select: [:e| string, '*' match: e asString] ];
			labelBlock: [ :e | e ].
			
	(composite 
		add: classRequest;
		add: methodRequest;
		add: thirdRequest;
				signal) inspect.! !

!GLMPresentation methodsFor: '*glamour-morphic-renderer' stamp: 'AndreiChis 12/3/2012 21:14'!
morphicAct: aBlock entitled: aString 
	 
	self addAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*glamour-morphic-renderer' stamp: 'AndreiChis 12/3/2012 21:14'!
morphicAct: aBlock icon: anIcon entitled: aString 
	 
	self addAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				title: aString; 
				icon: anIcon;
				yourself)! !

!GLMPresentation methodsFor: '*glamour-morphic-renderer' stamp: 'AndreiChis 12/3/2012 21:14'!
morphicAct: aBlock on: aCharacter entitled: aString 
	 
	self 
		addAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*glamour-morphic-renderer' stamp: 'AndreiChis 12/3/2012 21:14'!
morphicAct: aBlock on: aCharacter icon: anIcon entitled: aString 
	 
	self 
		addAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				shortcut: aCharacter; 
				icon: anIcon;
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*glamour-morphic-renderer' stamp: 'AndreiChis 12/3/2012 21:14'!
morphicPopulate: aPortSymbol icon: anIcon on: aCharacter entitled: aString with: aBlock 
	 
	self 
		addAction: 
			((GLMMorphicAction new) 
				action: 
						((GLMPortUpdater new) 
								portSymbol: aPortSymbol; 
								valueBlock: aBlock; 
								yourself); 
				shortcut: aCharacter; 
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: '*glamour-morphic-renderer' stamp: 'AndreiChis 12/3/2012 21:15'!
morphicSelectionAct: aBlock entitled: aString 
	 
	self addSelectionAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				title: aString; 
				yourself)! !

!GLMPresentation methodsFor: '*glamour-morphic-renderer' stamp: 'AndreiChis 12/3/2012 21:15'!
morphicSelectionAct: aBlock icon: anIcon entitled: aString
	self 
		addSelectionAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				icon: anIcon;
				title: aString;
				yourself)! !

!GLMPresentation methodsFor: '*glamour-morphic-renderer' stamp: 'AndreiChis 12/3/2012 21:15'!
morphicSelectionAct: aBlock icon: anIcon on: aCharacter entitled: aString
	self 
		addSelectionAction: 
			((GLMMorphicAction new) 
				action: aBlock; 
				shortcut: aCharacter; 				
				icon: anIcon;
				title: aString;
				yourself)! !

PluggableButtonMorph subclass: #GLMPluggableButtonMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer'!

!GLMPluggableButtonMorph methodsFor: 'as yet unclassified' stamp: 'DenisKudryashov 4/13/2016 15:06'!
model: anObject
	model := anObject! !

DialogWindow subclass: #GLMMorphicSingleSpotter
	instanceVariableNames: 'textMorph text listMorph listValues listLabels listIndex answer parent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMMorphicSingleSpotter class methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:05'!
on: aRequest
	^ self basicNew initializeOn: aRequest! !

!GLMMorphicSingleSpotter class methodsFor: 'instance creation' stamp: 'MirceaLungu 2/26/2011 17:59'!
on: aRequest parent: parent
	^ self basicNew initializeOn: aRequest parent: parent! !

!GLMMorphicSingleSpotter class methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:05'!
openOn: aRequest
	^ UITheme builder openModal: (self on: aRequest)! !

!GLMMorphicSingleSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:05'!
answer
	"Answer the result of the dialog or nil, if this dialog has been cancelled."
	
	^ answer! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
arrowKey: anEvent from: aMorph
	"Ignore this request."! !

!GLMMorphicSingleSpotter methodsFor: 'actions' stamp: 'ML 2/26/2011 17:05'!
cancel
	answer := nil.
	^ super cancel! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
clickIconAt: anInteger
	"Ignore this request."! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
defaultFocusMorph
	^ textMorph! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'MirceaLungu 2/26/2011 18:10'!
deselect
	self listIndex: 0.  ! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
doubleClick
	self ok! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:05'!
editorKeyStroke: anEvent
	anEvent keyCharacter = Character arrowDown ifTrue: [
		self listIndex: (self listIndex + 1 min: listValues size).
		^ true ].
	anEvent keyCharacter = Character arrowUp ifTrue: [
		self listIndex: (self listIndex - 1 max: 1). 
		^ true ].
	^ false! !

!GLMMorphicSingleSpotter methodsFor: 'callbacks' stamp: 'TudorGirba 10/25/2011 17:25'!
iconAt: anIndex
	^ model ifNotNil: [model iconFor: (listValues at: anIndex ifAbsent: [ ^ nil ])]! !

!GLMMorphicSingleSpotter methodsFor: 'initialization' stamp: 'ML 2/26/2011 17:05'!
initializeOn: aRequest
	model := aRequest.
	listValues := listLabels := #().
	listIndex := 0.
	self initialize.
	self title: aRequest prompt.
	self text: aRequest default
! !

!GLMMorphicSingleSpotter methodsFor: 'initialization' stamp: 'MirceaLungu 2/26/2011 18:05'!
initializeOn: aRequest parent: theParent
	parent := theParent.
	self initializeOn: aRequest.
! !

!GLMMorphicSingleSpotter methodsFor: 'testing' stamp: 'ML 2/26/2011 17:05'!
isAssisted
	^ self model assisted! !

!GLMMorphicSingleSpotter methodsFor: 'testing' stamp: 'ML 2/26/2011 17:05'!
isEnabled
	^ self model assisted
		ifTrue: [ self text isEmptyOrNil not ]
		ifFalse: [ self listIndex > 0 ]! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listIndex
	^ listIndex! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'MirceaLungu 2/26/2011 18:09'!
listIndex: anInteger
	anInteger isZero not ifTrue: [
		parent selectionIn: self.].
	listIndex = anInteger
		ifTrue: [ ^ self ].
	listIndex := anInteger.
	self listSelection ifNotNil: [ :selection |
		self isAssisted ifTrue: [ 
			text := self model labelFor: self listSelection.
			self changed: #text ] ].
	self changed: #listIndex; changed: #isEnabled! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listLabels
	^ listLabels! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listSelection
	^ listValues at: self listIndex ifAbsent: [ nil ]! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'MirceaLungu 2/26/2011 18:04'!
listSelection: anObject

	self listIndex: (listValues indexOf: anObject ifAbsent: [ 0 ])! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listValues
	^ listValues! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-list' stamp: 'ML 2/26/2011 17:05'!
listValues: aCollection
	| previous |
	previous := self listSelection.
	listValues := aCollection asArray.
	listLabels := listValues
		collect: [ :each | model labelFor: each ].
	self changed: #listLabels; listSelection: previous! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
newContentMorph
	^ (self newColumn: { self newTextMorph. self newListMorph })
		minWidth: 320;
		minHeight: 200;
		yourself! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'TudorGirba 10/26/2011 16:04'!
newListMorph
	listMorph := PluggableListMorph
		on: self
		list: #listLabels
		selected: #listIndex
		changeSelected: #listIndex:.
	listMorph
		borderStyle: (self theme listNormalBorderStyleFor: listMorph);
		color: (self theme listNormalFillStyleFor: listMorph);
		cornerStyle: self preferredCornerStyle;
		doubleClickSelector: #doubleClick;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		autoDeselect: false.
	^ listMorph! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
newOKButton
	^ self newOKButtonFor: self getEnabled: #isEnabled! !

!GLMMorphicSingleSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:05'!
newTextMorph
	textMorph := self
		newTextEntryFor: self
		getText: #text
		setText: #text:
		help: nil.
	textMorph
		autoAccept: true;
		selectAll.
	textMorph textMorph
		on: #keyStroke send: #editorKeyStroke: to: self.
	^ textMorph! !

!GLMMorphicSingleSpotter methodsFor: 'actions' stamp: 'ML 2/26/2011 17:05'!
ok
	answer := self model assisted
		ifTrue: [ self text ]
		ifFalse: [ self listSelection ].
	^ super ok! !

!GLMMorphicSingleSpotter methodsFor: 'accessing' stamp: 'MirceaLungu 2/26/2011 17:58'!
parent
	^ parent! !

!GLMMorphicSingleSpotter methodsFor: 'accessing' stamp: 'MirceaLungu 2/26/2011 17:58'!
parent: anObject
	parent := anObject! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-text' stamp: 'ML 2/26/2011 17:05'!
text
	^ text! !

!GLMMorphicSingleSpotter methodsFor: 'accessing-text' stamp: 'ML 2/26/2011 17:05'!
text: aString
	text = aString
		ifTrue: [ ^ self ].
	text := aString.
	self listValues: (self model valuesFor: text).
	self isAssisted ifFalse: [
		self listIndex: (self listLabels size = 1
			ifTrue: [ 1 ]
			ifFalse: [ self listLabels findFirst: [ :each | each sameAs: text ] ]) ].
	self changed: #text; changed: #isEnabled! !

DialogWindow subclass: #GLMMorphicSpotter
	instanceVariableNames: 'textMorph text answer childrenMorphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Morphic-Renderer-Spotter'!

!GLMMorphicSpotter class methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:15'!
on: aRequest
	^ self basicNew initializeOn: aRequest! !

!GLMMorphicSpotter class methodsFor: 'instance creation' stamp: 'ML 2/26/2011 17:15'!
openOn: aRequest
	^ UITheme builder openModal: (self on: aRequest)! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
answer
	^ answer! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
answer: anObject
	answer := anObject! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
childrenMorphs
	^ childrenMorphs! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
childrenMorphs: anObject
	childrenMorphs := anObject! !

!GLMMorphicSpotter methodsFor: 'callbacks' stamp: 'ML 2/26/2011 17:21'!
editorKeyStroke: anEvent
"	anEvent keyCharacter = Character arrowDown ifTrue: [
		self listIndex: (self listIndex + 1 min: listValues size).
		^ true ].
	anEvent keyCharacter = Character arrowUp ifTrue: [
		self listIndex: (self listIndex - 1 max: 1). 
		^ true ]."
	^ false! !

!GLMMorphicSpotter methodsFor: 'initialization' stamp: 'ML 2/26/2011 17:18'!
initialize 
	childrenMorphs := OrderedCollection new.
	super initialize! !

!GLMMorphicSpotter methodsFor: 'initialization' stamp: 'ML 2/26/2011 17:16'!
initializeOn: aRequest
	model := aRequest.
	self initialize.
	self title: aRequest prompt.
	self text: aRequest default
! !

!GLMMorphicSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:21'!
newContentMorph
	^ (self newColumn: 
			((OrderedCollection with: self newTextMorph) addAll: self newListMorphs; yourself) )
		minWidth: 320;
		minHeight: 200;
		yourself! !

!GLMMorphicSpotter methodsFor: 'morphic' stamp: 'TudorGirba 2/27/2011 15:25'!
newListMorphs
	| list |
	self model requests do: [:each | 
		list := (GLMMorphicSingleSpotter on: each parent: self).
		self childrenMorphs add: list ].
	^ childrenMorphs collect: #newListMorph! !

!GLMMorphicSpotter methodsFor: 'morphic' stamp: 'ML 2/26/2011 17:13'!
newTextMorph
	textMorph := self
		newTextEntryFor: self
		getText: #text
		setText: #text:
		help: nil.
	textMorph
		autoAccept: true;
		selectAll.
	textMorph textMorph
		on: #keyStroke send: #editorKeyStroke: to: self.
	^ textMorph! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'VincentBlondeau 2/14/2014 17:02'!
ok
	| nonEmpty |
	nonEmpty := self childrenMorphs reject: [ :e | e listIndex isZero ].
	nonEmpty size = 1
		ifTrue: [ answer := nonEmpty first listSelection ].
	^ super ok! !

!GLMMorphicSpotter methodsFor: 'callbacks' stamp: 'MirceaLungu 2/26/2011 18:10'!
selectionIn: singleSpotlight

	(self childrenMorphs reject: [:e| e = singleSpotlight] ) do: [:e| 
			e deselect.
		]! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:08'!
text
	^ text! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:14'!
text: aString
	text = aString
		ifTrue: [ ^ self ].
	text := aString.
	self childrenMorphs do: [:each | each text: aString ].
	self changed: #text; changed: #isEnabled! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:07'!
textMorph
	^ textMorph! !

!GLMMorphicSpotter methodsFor: 'accessing' stamp: 'ML 2/26/2011 17:07'!
textMorph: anObject
	textMorph := anObject! !
